OGRE: Ogre::DefaultSceneManager Class Reference - OGRE Documentation

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::DefaultSceneManager Class Reference

Default scene manager. More...

`#include <OgreSceneManagerEnumerator.h>`

Inheritance diagram for Ogre::DefaultSceneManager:

[legend]
List of all members.

## Public Types

typedef MapIterator< CameraList > | CameraIterator
typedef MapIterator< AnimationList > | AnimationIterator
typedef MapIterator< MovableObjectMap > | MovableObjectIterator
enum | IlluminationRenderStage { IRS_NONE, IRS_RENDER_TO_TEXTURE, IRS_RENDER_RECEIVER_PASS }
| Describes the stage of rendering when performing complex illumination. More...
enum | SpecialCaseRenderQueueMode { SCRQM_INCLUDE, SCRQM_EXCLUDE }
| Enumeration of the possible modes allowed for processing the special case render queue list. More...
enum | PrefabType { PT_PLANE, PT_CUBE, PT_SPHERE }
| Prefab shapes available without loading a model. More...

## Public Member Functions

| DefaultSceneManager (const String &name)
| ~DefaultSceneManager ()
const String & | getTypeName (void) const
| Retrieve the type name of this scene manager.
const String & | getName (void) const
| Return the instance name of this SceneManager.
virtual Camera * | createCamera (const String &name)
| Creates a camera to be managed by this scene manager.
virtual Camera * | getCamera (const String &name) const
| Retrieves a pointer to the named camera.
virtual bool | hasCamera (const String &name) const
| Returns whether a camera with the given name exists.
virtual void | destroyCamera (Camera *cam)
| Removes a camera from the scene.
virtual void | destroyCamera (const String &name)
| Removes a camera from the scene.
virtual void | destroyAllCameras (void)
| Removes (and destroys) all cameras from the scene.
virtual Light * | createLight (const String &name)
| Creates a light for use in the scene.
virtual Light * | getLight (const String &name) const
| Returns a pointer to the named Light which has previously been added to the scene.
virtual bool | hasLight (const String &name) const
| Returns whether a light with the given name exists.
virtual void | destroyLight (const String &name)
| Removes the named light from the scene and destroys it.
virtual void | destroyLight (Light *light)
| Removes the light from the scene and destroys it based on a pointer.
virtual void | destroyAllLights (void)
| Removes and destroys all lights in the scene.
virtual void | _notifyLightsDirty (void)
| Advance method to increase the lights dirty counter due lights changed.
ulong | _getLightsDirtyCounter (void) const
| Advance method to gets the lights dirty counter.
virtual const LightList & | _getLightsAffectingFrustum (void) const
| Get the list of lights which could be affecting the frustum.
virtual void | _populateLightList (const Vector3 &position, Real radius, LightList &destList)
| Populate a light list with an ordered set of the lights which are closest to the position specified.
virtual SceneNode * | createSceneNode (void)
| Creates an instance of a SceneNode.
virtual SceneNode * | createSceneNode (const String &name)
| Creates an instance of a SceneNode with a given name.
virtual void | destroySceneNode (const String &name)
| Destroys a SceneNode with a given name.
virtual SceneNode * | getRootSceneNode (void) const
| Gets the SceneNode at the root of the scene hierarchy.
virtual SceneNode * | getSceneNode (const String &name) const
| Retrieves a named SceneNode from the scene graph.
virtual bool | hasSceneNode (const String &name) const
| Returns whether a scene node with the given name exists.
virtual Entity * | createEntity (const String &entityName, const String &meshName)
| Create an Entity (instance of a discrete mesh).
virtual Entity * | createEntity (const String &entityName, PrefabType ptype)
| Create an Entity (instance of a discrete mesh) from a range of prefab shapes.
virtual Entity * | getEntity (const String &name) const
| Retrieves a pointer to the named Entity.
virtual bool | hasEntity (const String &name) const
| Returns whether an entity with the given name exists.
virtual void | destroyEntity (Entity *ent)
| Removes & destroys an Entity from the SceneManager.
virtual void | destroyEntity (const String &name)
| Removes & destroys an Entity from the SceneManager by name.
virtual void | destroyAllEntities (void)
| Removes & destroys all Entities.
virtual ManualObject * | createManualObject (const String &name)
| Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface.
virtual ManualObject * | getManualObject (const String &name) const
| Retrieves a pointer to the named ManualObject.
virtual bool | hasManualObject (const String &name) const
| Returns whether a manual object with the given name exists.
virtual void | destroyManualObject (ManualObject *obj)
| Removes & destroys a ManualObject from the SceneManager.
virtual void | destroyManualObject (const String &name)
| Removes & destroys a ManualObject from the SceneManager.
virtual void | destroyAllManualObjects (void)
| Removes & destroys all ManualObjects from the SceneManager.
virtual BillboardChain * | createBillboardChain (const String &name)
| Create a BillboardChain, an object which you can use to render a linked chain of billboards.
virtual BillboardChain * | getBillboardChain (const String &name) const
| Retrieves a pointer to the named BillboardChain.
virtual bool | hasBillboardChain (const String &name) const
| Returns whether a billboard chain with the given name exists.
virtual void | destroyBillboardChain (BillboardChain *obj)
| Removes & destroys a BillboardChain from the SceneManager.
virtual void | destroyBillboardChain (const String &name)
| Removes & destroys a BillboardChain from the SceneManager.
virtual void | destroyAllBillboardChains (void)
| Removes & destroys all BillboardChains from the SceneManager.
virtual RibbonTrail * | createRibbonTrail (const String &name)
| Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes.
virtual RibbonTrail * | getRibbonTrail (const String &name) const
| Retrieves a pointer to the named RibbonTrail.
virtual bool | hasRibbonTrail (const String &name) const
| Returns whether a ribbon trail with the given name exists.
virtual void | destroyRibbonTrail (RibbonTrail *obj)
| Removes & destroys a RibbonTrail from the SceneManager.
virtual void | destroyRibbonTrail (const String &name)
| Removes & destroys a RibbonTrail from the SceneManager.
virtual void | destroyAllRibbonTrails (void)
| Removes & destroys all RibbonTrails from the SceneManager.
virtual ParticleSystem * | createParticleSystem (const String &name, const String &templateName)
| Creates a particle system based on a template.
virtual ParticleSystem * | createParticleSystem (const String &name, size_t quota=500, const String &resourceGroup=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Create a blank particle system.
virtual ParticleSystem * | getParticleSystem (const String &name) const
| Retrieves a pointer to the named ParticleSystem.
virtual bool | hasParticleSystem (const String &name) const
| Returns whether a particle system with the given name exists.
virtual void | destroyParticleSystem (ParticleSystem *obj)
| Removes & destroys a ParticleSystem from the SceneManager.
virtual void | destroyParticleSystem (const String &name)
| Removes & destroys a ParticleSystem from the SceneManager.
virtual void | destroyAllParticleSystems (void)
| Removes & destroys all ParticleSystems from the SceneManager.
virtual void | clearScene (void)
| Empties the entire scene, inluding all SceneNodes, Entities, Lights, BillboardSets etc.
void | setAmbientLight (const ColourValue &colour)
| Sets the ambient light level to be used for the scene.
const ColourValue & | getAmbientLight (void) const
| Returns the ambient light level to be used for the scene.
virtual void | setWorldGeometry (const String &filename)
| Sets the source of the 'world' geometry, i.e.
virtual void | setWorldGeometry (DataStreamPtr &stream, const String &typeName=StringUtil::BLANK)
| Sets the source of the 'world' geometry, i.e.
virtual size_t | estimateWorldGeometry (const String &filename)
| Estimate the number of loading stages required to load the named world geometry.
virtual size_t | estimateWorldGeometry (DataStreamPtr &stream, const String &typeName=StringUtil::BLANK)
| Estimate the number of loading stages required to load the named world geometry.
virtual ViewPoint | getSuggestedViewpoint (bool random=false)
| Asks the SceneManager to provide a suggested viewpoint from which the scene should be viewed.
virtual bool | setOption (const String &strKey, const void *pValue)
| Method for setting a specific option of the Scene Manager.
virtual bool | getOption (const String &strKey, void *pDestValue)
| Method for getting the value of an implementation-specific Scene Manager option.
virtual bool | hasOption (const String &strKey) const
| Method for verifying wether the scene manager has an implementation-specific option.
virtual bool | getOptionValues (const String &strKey, StringVector &refValueList)
| Method for getting all possible values for a specific option.
virtual bool | getOptionKeys (StringVector &refKeys)
| Method for getting all the implementation-specific options of the scene manager.
virtual void | _updateSceneGraph (Camera *cam)
| Internal method for updating the scene graph ie the tree of SceneNode instances managed by this class.
virtual void | _findVisibleObjects (Camera *cam, VisibleObjectsBoundsInfo *visibleBounds, bool onlyShadowCasters)
| Internal method which parses the scene to find visible objects to render.
virtual void | _applySceneAnimations (void)
| Internal method for applying animations to scene nodes.
virtual void | _renderVisibleObjects (void)
| Sends visible objects found in _findVisibleObjects to the rendering engine.
virtual void | _renderScene (Camera *camera, Viewport *vp, bool includeOverlays)
| Prompts the class to send its contents to the renderer.
virtual void | _queueSkiesForRendering (Camera *cam)
| Internal method for queueing the sky objects with the params as previously set through setSkyBox, setSkyPlane and setSkyDome.
virtual void | _setDestinationRenderSystem (RenderSystem *sys)
| Notifies the scene manager of its destination render system.
virtual void | setSkyPlane (bool enable, const Plane &plane, const String &materialName, Real scale=1000, Real tiling=10, bool drawFirst=true, Real bow=0, int xsegments=1, int ysegments=1, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky plane' i.e.
virtual bool | isSkyPlaneEnabled (void) const
| Return whether a key plane is enabled.
virtual SceneNode * | getSkyPlaneNode (void) const
| Get the sky plane node, if enabled.
virtual const SkyPlaneGenParameters & | getSkyPlaneGenParameters (void) const
| Get the parameters used to construct the SkyPlane, if any *.
virtual void | setSkyBox (bool enable, const String &materialName, Real distance=5000, bool drawFirst=true, const Quaternion &orientation=Quaternion::IDENTITY, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky box' i.e.
virtual bool | isSkyBoxEnabled (void) const
| Return whether a skybox is enabled.
virtual SceneNode * | getSkyBoxNode (void) const
| Get the skybox node, if enabled.
virtual const SkyBoxGenParameters & | getSkyBoxGenParameters (void) const
| Get the parameters used to generate the current SkyBox, if any.
virtual void | setSkyDome (bool enable, const String &materialName, Real curvature=10, Real tiling=8, Real distance=4000, bool drawFirst=true, const Quaternion &orientation=Quaternion::IDENTITY, int xsegments=16, int ysegments=16, int ysegments_keep=-1, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Enables / disables a 'sky dome' i.e.
virtual bool | isSkyDomeEnabled (void) const
| Return whether a skydome is enabled.
virtual SceneNode * | getSkyDomeNode (void) const
| Get the sky dome node, if enabled.
virtual const SkyDomeGenParameters & | getSkyDomeGenParameters (void) const
| Get the parameters used to generate the current SkyDome, if any.
void | setFog (FogMode mode=FOG_NONE, const ColourValue &colour=ColourValue::White, Real expDensity=0.001, Real linearStart=0.0, Real linearEnd=1.0)
| Sets the fogging mode applied to the scene.
virtual FogMode | getFogMode (void) const
| Returns the fog mode for the scene.
virtual const ColourValue & | getFogColour (void) const
| Returns the fog colour for the scene.
virtual Real | getFogStart (void) const
| Returns the fog start distance for the scene.
virtual Real | getFogEnd (void) const
| Returns the fog end distance for the scene.
virtual Real | getFogDensity (void) const
| Returns the fog density for the scene.
virtual BillboardSet * | createBillboardSet (const String &name, unsigned int poolSize=20)
| Creates a new BillboardSet for use with this scene manager.
virtual BillboardSet * | getBillboardSet (const String &name) const
| Retrieves a pointer to the named BillboardSet.
virtual bool | hasBillboardSet (const String &name) const
| Returns whether a billboardset with the given name exists.
virtual void | destroyBillboardSet (BillboardSet *set)
| Removes & destroys an BillboardSet from the SceneManager.
virtual void | destroyBillboardSet (const String &name)
| Removes & destroys an BillboardSet from the SceneManager by name.
virtual void | destroyAllBillboardSets (void)
| Removes & destroys all BillboardSets.
virtual void | setDisplaySceneNodes (bool display)
| Tells the SceneManager whether it should render the SceneNodes which make up the scene as well as the objects in the scene.
virtual bool | getDisplaySceneNodes (void) const
| Returns true if all scene nodes axis are to be displayed.
virtual Animation * | createAnimation (const String &name, Real length)
| Creates an animation which can be used to animate scene nodes.
virtual Animation * | getAnimation (const String &name) const
| Looks up an Animation object previously created with createAnimation.
virtual bool | hasAnimation (const String &name) const
| Returns whether an animation with the given name exists.
virtual void | destroyAnimation (const String &name)
| Destroys an Animation.
virtual void | destroyAllAnimations (void)
| Removes all animations created using this SceneManager.
virtual AnimationState * | createAnimationState (const String &animName)
| Create an AnimationState object for managing application of animations.
virtual AnimationState * | getAnimationState (const String &animName) const
| Retrieves animation state as previously created using createAnimationState.
virtual bool | hasAnimationState (const String &name) const
| Returns whether an animation state with the given name exists.
virtual void | destroyAnimationState (const String &name)
| Destroys an AnimationState.
virtual void | destroyAllAnimationStates (void)
| Removes all animation states created using this SceneManager.
virtual void | manualRender (RenderOperation *rend, Pass *pass, Viewport *vp, const Matrix4 &worldMatrix, const Matrix4 &viewMatrix, const Matrix4 &projMatrix, bool doBeginEndFrame=false)
| Manual rendering method, for advanced users only.
virtual RenderQueue * | getRenderQueue (void)
| Retrieves the internal render queue, for advanced users only.
virtual void | addRenderQueueListener (RenderQueueListener *newListener)
| Registers a new RenderQueueListener which will be notified when render queues are processed.
virtual void | removeRenderQueueListener (RenderQueueListener *delListener)
| Removes a listener previously added with addRenderQueueListener.
virtual void | addSpecialCaseRenderQueue (uint8 qid)
| Adds an item to the 'special case' render queue list.
virtual void | removeSpecialCaseRenderQueue (uint8 qid)
| Removes an item to the 'special case' render queue list.
virtual void | clearSpecialCaseRenderQueues (void)
| Clears the 'special case' render queue list.
virtual void | setSpecialCaseRenderQueueMode (SpecialCaseRenderQueueMode mode)
| Sets the way the special case render queue list is processed.
virtual SpecialCaseRenderQueueMode | getSpecialCaseRenderQueueMode (void)
| Gets the way the special case render queue list is processed.
virtual bool | isRenderQueueToBeProcessed (uint8 qid)
| Returns whether or not the named queue will be rendered based on the current 'special case' render queue list and mode.
virtual void | setWorldGeometryRenderQueue (uint8 qid)
| Sets the render queue that the world geometry (if any) this SceneManager renders will be associated with.
virtual uint8 | getWorldGeometryRenderQueue (void)
| Gets the render queue that the world geometry (if any) this SceneManager renders will be associated with.
virtual void | showBoundingBoxes (bool bShow)
| Allows all bounding boxes of scene nodes to be displayed.
virtual bool | getShowBoundingBoxes () const
| Returns if all bounding boxes of scene nodes are to be displayed.
virtual void | _notifyAutotrackingSceneNode (SceneNode *node, bool autoTrack)
| Internal method for notifying the manager that a SceneNode is autotracking.
virtual AxisAlignedBoxSceneQuery * | createAABBQuery (const AxisAlignedBox &box, unsigned long mask=0xFFFFFFFF)
| Creates an AxisAlignedBoxSceneQuery for this scene manager.
virtual SphereSceneQuery * | createSphereQuery (const Sphere &sphere, unsigned long mask=0xFFFFFFFF)
| Creates a SphereSceneQuery for this scene manager.
virtual PlaneBoundedVolumeListSceneQuery * | createPlaneBoundedVolumeQuery (const PlaneBoundedVolumeList &volumes, unsigned long mask=0xFFFFFFFF)
| Creates a PlaneBoundedVolumeListSceneQuery for this scene manager.
virtual RaySceneQuery * | createRayQuery (const Ray &ray, unsigned long mask=0xFFFFFFFF)
| Creates a RaySceneQuery for this scene manager.
virtual IntersectionSceneQuery * | createIntersectionQuery (unsigned long mask=0xFFFFFFFF)
| Creates an IntersectionSceneQuery for this scene manager.
virtual void | destroyQuery (SceneQuery *query)
| Destroys a scene query of any type.
CameraIterator | getCameraIterator (void)
| Returns a specialised MapIterator over all cameras in the scene.
AnimationIterator | getAnimationIterator (void)
| Returns a specialised MapIterator over all animations in the scene.
AnimationStateIterator | getAnimationStateIterator (void)
| Returns a specialised MapIterator over all animation states in the scene.
virtual void | setShadowTechnique (ShadowTechnique technique)
| Sets the general shadow technique to be used in this scene.
virtual ShadowTechnique | getShadowTechnique (void) const
| Gets the current shadow technique.
virtual void | setShowDebugShadows (bool debug)
| Enables / disables the rendering of debug information for shadows.
virtual bool | getShowDebugShadows (void) const
| Are debug shadows shown?
virtual void | setShadowColour (const ColourValue &colour)
| Set the colour used to modulate areas in shadow.
virtual const ColourValue & | getShadowColour (void) const
| Get the colour used to modulate areas in shadow.
virtual void | setShadowDirectionalLightExtrusionDistance (Real dist)
| Sets the distance a shadow volume is extruded for a directional light.
virtual Real | getShadowDirectionalLightExtrusionDistance (void) const
| Gets the distance a shadow volume is extruded for a directional light.
virtual void | setShadowFarDistance (Real distance)
| Sets the maximum distance away from the camera that shadows will be visible.
virtual Real | getShadowFarDistance (void) const
| Gets the maximum distance away from the camera that shadows will be visible.
virtual void | setShadowIndexBufferSize (size_t size)
| Sets the maximum size of the index buffer used to render shadow primitives.
virtual size_t | getShadowIndexBufferSize (void) const
| Get the size of the shadow index buffer.
virtual void | setShadowTextureSize (unsigned short size)
| Set the size of the texture used for all texture-based shadows.
virtual void | setShadowTextureConfig (size_t shadowIndex, unsigned short width, unsigned short height, PixelFormat format)
| Set the detailed configuration for a shadow texture.
virtual void | setShadowTextureConfig (size_t shadowIndex, const ShadowTextureConfig &config)
| Set the detailed configuration for a shadow texture.
ConstShadowTextureConfigIterator | getShadowTextureConfigIterator () const
| Get an iterator over the current shadow texture settings.
virtual void | setShadowTexturePixelFormat (PixelFormat fmt)
| Set the pixel format of the textures used for texture-based shadows.
virtual void | setShadowTextureCount (size_t count)
| Set the number of textures allocated for texture-based shadows.
size_t | getShadowTextureCount (void) const
| Get the number of the textures allocated for texture based shadows.
virtual void | setShadowTextureSettings (unsigned short size, unsigned short count, PixelFormat fmt=PF_X8R8G8B8)
| Sets the size and count of textures used in texture-based shadows.
virtual const TexturePtr & | getShadowTexture (size_t shadowIndex)
| Get a reference to the shadow texture currently in use at the given index.
virtual void | setShadowDirLightTextureOffset (Real offset)
| Sets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
virtual Real | getShadowDirLightTextureOffset (void) const
| Gets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.
virtual void | setShadowTextureFadeStart (Real fadeStart)
| Sets the proportional distance at which texture shadows begin to fade out.
virtual void | setShadowTextureFadeEnd (Real fadeEnd)
| Sets the proportional distance at which texture shadows finish to fading out.
virtual void | setShadowTextureSelfShadow (bool selfShadow)
| Sets whether or not texture shadows should attempt to self-shadow.
virtual bool | getShadowTextureSelfShadow (void) const
| Gets whether or not texture shadows attempt to self-shadow.
virtual void | setShadowTextureCasterMaterial (const String &name)
| Sets the default material to use for rendering shadow casters.
virtual void | setShadowTextureReceiverMaterial (const String &name)
| Sets the default material to use for rendering shadow receivers.
virtual void | setShadowCasterRenderBackFaces (bool bf)
| Sets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.
virtual bool | getShadowCasterRenderBackFaces () const
| Gets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.
virtual void | setShadowCameraSetup (const ShadowCameraSetupPtr &shadowSetup)
| Set the shadow camera setup to use for all lights which don't have their own shadow camera setup.
virtual const ShadowCameraSetupPtr & | getShadowCameraSetup () const
| Get the shadow camera setup in use for all lights which don't have their own shadow camera setup.
virtual void | setShadowUseInfiniteFarPlane (bool enable)
| Sets whether we should use an inifinite camera far plane when rendering stencil shadows.
virtual bool | isShadowTechniqueStencilBased (void) const
| Is there a stencil shadow based shadowing technique in use?
virtual bool | isShadowTechniqueTextureBased (void) const
| Is there a texture shadow based shadowing technique in use?
virtual bool | isShadowTechniqueModulative (void) const
| Is there a modulative shadowing technique in use?
virtual bool | isShadowTechniqueAdditive (void) const
| Is there an additive shadowing technique in use?
virtual bool | isShadowTechniqueIntegrated (void) const
| Is the shadow technique integrated into primary materials?
virtual bool | isShadowTechniqueInUse (void) const
| Is there any shadowing technique in use?
virtual void | addShadowListener (ShadowListener *s)
| Add a shadow listener which will get called back on shadow events.
virtual void | removeShadowListener (ShadowListener *s)
| Remove a shadow listener.
virtual StaticGeometry * | createStaticGeometry (const String &name)
| Creates a StaticGeometry instance suitable for use with this SceneManager.
virtual StaticGeometry * | getStaticGeometry (const String &name) const
| Retrieve a previously created StaticGeometry instance.
virtual bool | hasStaticGeometry (const String &name) const
| Returns whether a static geometry instance with the given name exists.
virtual void | destroyStaticGeometry (StaticGeometry *geom)
| Remove & destroy a StaticGeometry instance.
virtual void | destroyStaticGeometry (const String &name)
| Remove & destroy a StaticGeometry instance.
virtual void | destroyAllStaticGeometry (void)
| Remove & destroy all StaticGeometry instances.
virtual InstancedGeometry * | createInstancedGeometry (const String &name)
| Creates a InstancedGeometry instance suitable for use with this SceneManager.
virtual InstancedGeometry * | getInstancedGeometry (const String &name) const
| Retrieve a previously created InstancedGeometry instance.
virtual void | destroyInstancedGeometry (InstancedGeometry *geom)
| Remove & destroy a InstancedGeometry instance.
virtual void | destroyInstancedGeometry (const String &name)
| Remove & destroy a InstancedGeometry instance.
virtual void | destroyAllInstancedGeometry (void)
| Remove & destroy all InstancedGeometry instances.
virtual MovableObject * | createMovableObject (const String &name, const String &typeName, const NameValuePairList *params=0)
| Create a movable object of the type specified.
virtual void | destroyMovableObject (const String &name, const String &typeName)
| Destroys a MovableObject with the name specified, of the type specified.
virtual void | destroyMovableObject (MovableObject *m)
| Destroys a MovableObject.
virtual void | destroyAllMovableObjectsByType (const String &typeName)
| Destroy all MovableObjects of a given type.
virtual void | destroyAllMovableObjects (void)
| Destroy all MovableObjects.
virtual MovableObject * | getMovableObject (const String &name, const String &typeName) const
| Get a reference to a previously created MovableObject.
virtual bool | hasMovableObject (const String &name, const String &typeName) const
| Returns whether a movable object instance with the given name exists.
virtual MovableObjectIterator | getMovableObjectIterator (const String &typeName)
| Get an iterator over all MovableObect instances of a given type.
virtual void | injectMovableObject (MovableObject *m)
| Inject a MovableObject instance created externally.
virtual void | extractMovableObject (const String &name, const String &typeName)
| Extract a previously injected MovableObject.
virtual void | extractMovableObject (MovableObject *m)
| Extract a previously injected MovableObject.
virtual void | extractAllMovableObjectsByType (const String &typeName)
| Extract all injected MovableObjects of a given type.
virtual void | setVisibilityMask (uint32 vmask)
| Sets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
virtual uint32 | getVisibilityMask (void)
| Gets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.
uint32 | _getCombinedVisibilityMask (void) const
| Internal method for getting the combination between the global visibility mask and the per-viewport visibility mask.
virtual void | setFindVisibleObjects (bool find)
| Sets whether the SceneManager should search for visible objects, or whether they are being manually handled.
virtual bool | getFindVisibleObjects (void)
| Gets whether the SceneManager should search for visible objects, or whether they are being manually handled.
virtual void | _injectRenderWithPass (Pass *pass, Renderable *rend, bool shadowDerivation=true)
| Render something as if it came from the current queue.
virtual void | _suppressRenderStateChanges (bool suppress)
| Indicates to the SceneManager whether it should suppress changing the RenderSystem states when rendering objects.
virtual bool | _areRenderStateChangesSuppressed (void) const
| Are render state changes suppressed?
virtual const Pass * | _setPass (const Pass *pass, bool evenIfSuppressed=false, bool shadowDerivation=true)
| Internal method for setting up the renderstate for a rendering pass.
virtual void | _suppressShadows (bool suppress)
| Indicates to the SceneManager whether it should suppress the active shadow rendering technique until told otherwise.
virtual bool | _areShadowsSuppressed (void) const
| Are shadows suppressed?
virtual void | _renderQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render the objects in a given queue group.
void | setQueuedRenderableVisitor (SceneMgrQueuedRenderableVisitor *visitor)
| Advanced method for supplying an alternative visitor, used for parsing the render queues and sending the results to the renderer.
SceneMgrQueuedRenderableVisitor * | getQueuedRenderableVisitor (void) const
| Gets the current visitor object which processes queued renderables.
RenderSystem * | getDestinationRenderSystem ()
| Get the rendersystem subclass to which the output of this Scene Manager gets sent.
Viewport * | getCurrentViewport (void) const
| Gets the current viewport being rendered (advanced use only, only valid during viewport update.
const VisibleObjectsBoundsInfo & | getVisibleObjectsBoundsInfo (const Camera *cam) const
| Returns a visibility boundary box for a specific camera.
const VisibleObjectsBoundsInfo & | getShadowCasterBoundsInfo (const Light *light) const
| Returns the shadow caster AAB for a specific light-camera combination.

## Static Public Attributes

static uint32 | WORLD_GEOMETRY_TYPE_MASK
| Query type mask which will be used for world geometry SceneQuery.
static uint32 | ENTITY_TYPE_MASK
| Query type mask which will be used for entities SceneQuery.
static uint32 | FX_TYPE_MASK
| Query type mask which will be used for effects like billboardsets / particle systems SceneQuery.
static uint32 | STATICGEOMETRY_TYPE_MASK
| Query type mask which will be used for StaticGeometry SceneQuery.
static uint32 | LIGHT_TYPE_MASK
| Query type mask which will be used for lights SceneQuery.
static uint32 | USER_TYPE_MASK_LIMIT
| User type mask limit.

## Protected Types

typedef std::map< String, Camera * > | CameraList
typedef std::map< String, StaticGeometry * > | StaticGeometryList
typedef std::map< String, InstancedGeometry * > | InstancedGeometryList
typedef std::map< String, SceneNode * > | SceneNodeList
typedef std::set< SceneNode * > | AutoTrackingSceneNodes
| Autotracking scene nodes.
typedef std::set< uint8 > | SpecialCaseRenderQueueList
typedef std::map< const Camera *, VisibleObjectsBoundsInfo > | CamVisibleObjectsMap
| Visible objects bounding box list.
typedef std::map< const Camera *, const Light * > | ShadowCamLightMapping
| ShadowCamera to light mapping.
typedef std::vector< LightInfo > | LightInfoList
typedef std::map< String, MovableObject * > | MovableObjectMap
typedef std::map< String, MovableObjectCollection * > | MovableObjectCollectionMap
typedef std::map< String, Animation * > | AnimationList
| Storage of animations, lookup by name.
typedef std::vector< RenderQueueListener * > | RenderQueueListenerList
typedef std::vector< ShadowListener * > | ShadowListenerList
typedef std::vector< Camera * > | ShadowTextureCameraList
typedef std::vector< ShadowCaster * > | ShadowCasterList
enum | BoxPlane { BP_FRONT = 0, BP_BACK = 1, BP_LEFT = 2, BP_RIGHT = 3, BP_UP = 4, BP_DOWN = 5 }

## Protected Member Functions

MovableObjectCollection * | getMovableObjectCollection (const String &typeName)
| Gets the movable object collection for the given type name.
const MovableObjectCollection * | getMovableObjectCollection (const String &typeName) const
| Gets the movable object collection for the given type name.
virtual void | initRenderQueue (void)
| Internal method for initialising the render queue.
virtual const Pass * | deriveShadowCasterPass (const Pass *pass)
| Internal method for turning a regular pass into a shadow caster pass.
virtual const Pass * | deriveShadowReceiverPass (const Pass *pass)
| Internal method for turning a regular pass into a shadow receiver pass.
virtual bool | validatePassForRendering (const Pass *pass)
| Internal method to validate whether a Pass should be allowed to render.
virtual bool | validateRenderableForRendering (const Pass *pass, const Renderable *rend)
| Internal method to validate whether a Renderable should be allowed to render.
virtual MeshPtr | createSkyboxPlane (BoxPlane bp, Real distance, const Quaternion &orientation, const String &groupName)
virtual MeshPtr | createSkydomePlane (BoxPlane bp, Real curvature, Real tiling, Real distance, const Quaternion &orientation, int xsegments, int ysegments, int ySegmentsToKeep, const String &groupName)
virtual void | useRenderableViewProjMode (const Renderable *pRend)
| Internal method used by _renderSingleObject to deal with renderables which override the camera's own view / projection materices.
virtual void | resetViewProjMode (void)
| Internal method used by _renderSingleObject to deal with renderables which override the camera's own view / projection matrices.
virtual bool | fireRenderQueueStarted (uint8 id, const String &invocation)
| Internal method for firing the queue start event, returns true if queue is to be skipped.
virtual bool | fireRenderQueueEnded (uint8 id, const String &invocation)
| Internal method for firing the queue end event, returns true if queue is to be repeated.
virtual void | fireShadowTexturesUpdated (size_t numberOfShadowTextures)
| Internal method for firing the texture shadows updated event.
virtual void | fireShadowTexturesPreCaster (Light *light, Camera *camera)
| Internal method for firing the pre caster texture shadows event.
virtual void | fireShadowTexturesPreReceiver (Light *light, Frustum *f)
| Internal method for firing the pre receiver texture shadows event.
virtual void | setViewport (Viewport *vp)
| Internal method for setting the destination viewport for the next render.
virtual void | renderVisibleObjectsDefaultSequence (void)
| Internal method for rendering all objects using the default queue sequence.
virtual void | renderVisibleObjectsCustomSequence (RenderQueueInvocationSequence *s)
| Internal method for rendering all objects using a custom queue sequence.
virtual void | prepareRenderQueue (void)
| Internal method for preparing the render queue for use with each render.
virtual void | renderSingleObject (const Renderable *rend, const Pass *pass, bool doLightIteration, const LightList *manualLightList=0)
| Internal utility method for rendering a single object.
virtual void | findLightsAffectingFrustum (const Camera *camera)
| Internal method for locating a list of lights which could be affecting the frustum.
virtual void | initShadowVolumeMaterials (void)
| Internal method for setting up materials for shadows.
virtual void | ensureShadowTexturesCreated ()
| Internal method for creating shadow textures (texture-based shadows).
virtual void | destroyShadowTextures (void)
| Internal method for destroying shadow textures (texture-based shadows).
virtual void | prepareShadowTextures (Camera *cam, Viewport *vp)
| Internal method for preparing shadow textures ready for use in a regular render.
virtual void | renderShadowVolumesToStencil (const Light *light, const Camera *cam)
| Internal method for rendering all the objects for a given light into the stencil buffer.
virtual void | setShadowVolumeStencilState (bool secondpass, bool zfail, bool twosided)
| Internal utility method for setting stencil state for rendering shadow volumes.
void | renderShadowVolumeObjects (ShadowCaster::ShadowRenderableListIterator iShadowRenderables, Pass *pass, const LightList *manualLightList, unsigned long flags, bool secondpass, bool zfail, bool twosided)
| Render a set of shadow renderables.
virtual const ShadowCasterList & | findShadowCastersForLight (const Light *light, const Camera *camera)
| Internal method for locating a list of shadow casters which could be affecting the frustum for a given light.
virtual void | renderBasicQueueGroupObjects (RenderQueueGroup *pGroup, QueuedRenderableCollection::OrganisationMode om)
| Render a group in the ordinary way.
virtual void | renderAdditiveStencilShadowedQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group with the added complexity of additive stencil shadows.
virtual void | renderModulativeStencilShadowedQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group with the added complexity of modulative stencil shadows.
virtual void | renderTextureShadowCasterQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group rendering only shadow casters.
virtual void | renderTextureShadowReceiverQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group rendering only shadow receivers.
virtual void | renderModulativeTextureShadowedQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group with the added complexity of modulative texture shadows.
virtual void | renderAdditiveTextureShadowedQueueGroupObjects (RenderQueueGroup *group, QueuedRenderableCollection::OrganisationMode om)
| Render a group with additive texture shadows.
virtual void | renderObjects (const QueuedRenderableCollection &objs, QueuedRenderableCollection::OrganisationMode om, bool doLightIteration, const LightList *manualLightList=0)
| Render a set of objects, see renderSingleObject for param definitions.
virtual void | renderTransparentShadowCasterObjects (const QueuedRenderableCollection &objs, QueuedRenderableCollection::OrganisationMode om, bool doLightIteration, const LightList *manualLightList=0)
| Render those objects in the transparent pass list which have shadow casting forced on.
virtual void | updateRenderQueueSplitOptions (void)
| Update the state of the global render queue splitting based on a shadow option change.
virtual void | updateRenderQueueGroupSplitOptions (RenderQueueGroup *group, bool suppressShadows, bool suppressRenderState)
| Update the state of the render queue group splitting based on a shadow option change.

## Protected Attributes

String | mName
| Instance name.
RenderQueue * | mRenderQueue
| Queue of objects for rendering.
ColourValue | mAmbientLight
| Current ambient light, cached for RenderSystem.
RenderSystem * | mDestRenderSystem
| The rendering system to send the scene to.
CameraList | mCameras
| Central list of cameras - for easy memory management and lookup.
StaticGeometryList | mStaticGeometryList
InstancedGeometryList | mInstancedGeometryList
SceneNodeList | mSceneNodes
| Central list of SceneNodes - for easy memory management.
Camera * | mCameraInProgress
| Camera in progress.
Viewport * | mCurrentViewport
| Current Viewport.
SceneNode * | mSceneRoot
| Root scene node.
AutoTrackingSceneNodes | mAutoTrackingSceneNodes
Entity * | mSkyPlaneEntity
Entity * | mSkyDomeEntity [5]
Entity * | mSkyBoxEntity [6]
SceneNode * | mSkyPlaneNode
SceneNode * | mSkyDomeNode
SceneNode * | mSkyBoxNode
bool | mSkyPlaneEnabled
bool | mSkyPlaneDrawFirst
Plane | mSkyPlane
SkyPlaneGenParameters | mSkyPlaneGenParameters
bool | mSkyBoxEnabled
bool | mSkyBoxDrawFirst
Quaternion | mSkyBoxOrientation
SkyBoxGenParameters | mSkyBoxGenParameters
bool | mSkyDomeEnabled
bool | mSkyDomeDrawFirst
Quaternion | mSkyDomeOrientation
SkyDomeGenParameters | mSkyDomeGenParameters
FogMode | mFogMode
ColourValue | mFogColour
Real | mFogStart
Real | mFogEnd
Real | mFogDensity
SpecialCaseRenderQueueList | mSpecialCaseQueueList
SpecialCaseRenderQueueMode | mSpecialCaseQueueMode
uint8 | mWorldGeometryRenderQueue
unsigned long | mLastFrameNumber
Matrix4 | mTempXform [256]
bool | mResetIdentityView
bool | mResetIdentityProj
CamVisibleObjectsMap | mCamVisibleObjectsMap
ShadowCamLightMapping | mShadowCamLightMapping
LightList | mLightsAffectingFrustum
LightInfoList | mCachedLightInfos
LightInfoList | mTestLightInfos
ulong | mLightsDirtyCounter
MovableObjectCollectionMap | mMovableObjectCollectionMap
Pass * | mShadowCasterPlainBlackPass
| A pass designed to let us render shadow colour on white for texture shadows.
Pass * | mShadowReceiverPass
| A pass designed to let us render shadow receivers for texture shadows.
bool | mDisplayNodes
AnimationList | mAnimationsList
AnimationStateSet | mAnimationStates
RenderQueueListenerList | mRenderQueueListeners
ShadowListenerList | mShadowListeners
bool | mShowBoundingBoxes
| Flag that indicates if all of the scene node's bounding boxes should be shown as a wireframe.
AutoParamDataSource | mAutoParamDataSource
| Utility class for calculating automatic parameters for gpu programs.
ShadowTechnique | mShadowTechnique
bool | mDebugShadows
ColourValue | mShadowColour
Pass * | mShadowDebugPass
Pass * | mShadowStencilPass
Pass * | mShadowModulativePass
bool | mShadowMaterialInitDone
HardwareIndexBufferSharedPtr | mShadowIndexBuffer
size_t | mShadowIndexBufferSize
Rectangle2D * | mFullScreenQuad
Real | mShadowDirLightExtrudeDist
IlluminationRenderStage | mIlluminationStage
ShadowTextureConfigList | mShadowTextureConfigList
bool | mShadowTextureConfigDirty
ShadowTextureList | mShadowTextures
TexturePtr | mNullShadowTexture
ShadowTextureCameraList | mShadowTextureCameras
Texture * | mCurrentShadowTexture
bool | mShadowUseInfiniteFarPlane
bool | mShadowCasterRenderBackFaces
ShadowCameraSetupPtr | mDefaultShadowCameraSetup
| default shadow camera setup
ShadowCasterList | mShadowCasterList
SphereSceneQuery * | mShadowCasterSphereQuery
AxisAlignedBoxSceneQuery * | mShadowCasterAABBQuery
Real | mShadowFarDist
Real | mShadowFarDistSquared
Real | mShadowTextureOffset
Real | mShadowTextureFadeStart
Real | mShadowTextureFadeEnd
bool | mShadowTextureSelfShadow
Pass * | mShadowTextureCustomCasterPass
Pass * | mShadowTextureCustomReceiverPass
String | mShadowTextureCustomCasterVertexProgram
String | mShadowTextureCustomReceiverVertexProgram
String | mShadowTextureCustomReceiverFragmentProgram
GpuProgramParametersSharedPtr | mShadowTextureCustomCasterVPParams
GpuProgramParametersSharedPtr | mShadowTextureCustomReceiverVPParams
GpuProgramParametersSharedPtr | mShadowTextureCustomReceiverFPParams
uint32 | mVisibilityMask
| Visibility mask used to show / hide objects.
bool | mFindVisibleObjects
bool | mSuppressRenderStateChanges
| Suppress render state changes?
bool | mSuppressShadows
| Suppress shadows?
GpuProgramParametersSharedPtr | mInfiniteExtrusionParams
GpuProgramParametersSharedPtr | mFiniteExtrusionParams
ShadowCasterSceneQueryListener * | mShadowCasterQueryListener
SceneMgrQueuedRenderableVisitor * | mActiveQueuedRenderableVisitor
| The active renderable visitor class - subclasses could override this.
SceneMgrQueuedRenderableVisitor | mDefaultQueuedRenderableVisitor
| Storage for default renderable visitor.

## Friends

class | SceneMgrQueuedRenderableVisitor
| Allow visitor helper to access protected methods.

## Detailed Description

Default scene manager.

Definition at line 54 of file OgreSceneManagerEnumerator.h.

## Member Typedef Documentation

typedef MapIterator<AnimationList> Ogre::SceneManager::AnimationIterator`[inherited]`

| Definition at line 2090 of file OgreSceneManager.h.

typedef std::map<String, Animation*> Ogre::SceneManager::AnimationList`[protected, inherited]`

| Storage of animations, lookup by name. Definition at line 522 of file OgreSceneManager.h.

typedef std::set<SceneNode*> Ogre::SceneManager::AutoTrackingSceneNodes`[protected, inherited]`

| Autotracking scene nodes. Definition at line 335 of file OgreSceneManager.h.

typedef MapIterator<CameraList> Ogre::SceneManager::CameraIterator`[inherited]`

| Definition at line 2089 of file OgreSceneManager.h.

typedef std::map<String, Camera* > Ogre::SceneManager::CameraList`[protected, inherited]`

| Definition at line 305 of file OgreSceneManager.h.

typedef std::map< const Camera*, VisibleObjectsBoundsInfo> Ogre::SceneManager::CamVisibleObjectsMap`[protected, inherited]`

Visible objects bounding box list.

Remarks:
  Holds an ABB for each camera that contains the physical extends of the visible scene elements by each camera. The map is crutial for shadow algorithms which have a focus step to limit the shadow sample distribution to only valid visible scene elements.

Definition at line 390 of file OgreSceneManager.h.

typedef std::map<String, InstancedGeometry* > Ogre::SceneManager::InstancedGeometryList`[protected, inherited]`

| Definition at line 313 of file OgreSceneManager.h.

typedef std::vector<LightInfo> Ogre::SceneManager::LightInfoList`[protected, inherited]`

| Definition at line 417 of file OgreSceneManager.h.

typedef std::map<String, MovableObjectCollection*> Ogre::SceneManager::MovableObjectCollectionMap`[protected, inherited]`

| Definition at line 431 of file OgreSceneManager.h.

typedef MapIterator<MovableObjectMap> Ogre::SceneManager::MovableObjectIterator`[inherited]`

| Definition at line 2569 of file OgreSceneManager.h.

typedef std::map<String, MovableObject*> Ogre::SceneManager::MovableObjectMap`[protected, inherited]`

| Definition at line 424 of file OgreSceneManager.h.

typedef std::vector<RenderQueueListener*> Ogre::SceneManager::RenderQueueListenerList`[protected, inherited]`

| Definition at line 536 of file OgreSceneManager.h.

typedef std::map<String, SceneNode*> Ogre::SceneManager::SceneNodeList`[protected, inherited]`

| Definition at line 316 of file OgreSceneManager.h.

typedef std::map< const Camera*, const Light* > Ogre::SceneManager::ShadowCamLightMapping`[protected, inherited]`

| ShadowCamera to light mapping. Definition at line 394 of file OgreSceneManager.h.

typedef std::vector<ShadowCaster*> Ogre::SceneManager::ShadowCasterList`[protected, inherited]`

| Definition at line 655 of file OgreSceneManager.h.

typedef std::vector<ShadowListener*> Ogre::SceneManager::ShadowListenerList`[protected, inherited]`

| Definition at line 539 of file OgreSceneManager.h.

typedef std::vector<Camera*> Ogre::SceneManager::ShadowTextureCameraList`[protected, inherited]`

| Definition at line 600 of file OgreSceneManager.h.

typedef std::set<uint8> Ogre::SceneManager::SpecialCaseRenderQueueList`[protected, inherited]`

| Definition at line 371 of file OgreSceneManager.h.

typedef std::map<String, StaticGeometry* > Ogre::SceneManager::StaticGeometryList`[protected, inherited]`

| Definition at line 311 of file OgreSceneManager.h.

## Member Enumeration Documentation

enum Ogre::SceneManager::BoxPlane`[protected, inherited]`

Enumeration values:

  BP_FRONT |
  BP_BACK |
  BP_LEFT |
  BP_RIGHT |
  BP_UP |
  BP_DOWN |

Definition at line 491 of file OgreSceneManager.h.

enum Ogre::SceneManager::IlluminationRenderStage`[inherited]`

Describes the stage of rendering when performing complex illumination.

Enumeration values:

  IRS_NONE | No special illumination stage.
  IRS_RENDER_TO_TEXTURE | Render to texture stage, used for texture based shadows.
  IRS_RENDER_RECEIVER_PASS | Render from shadow texture to receivers stage.

Definition at line 246 of file OgreSceneManager.h.

enum Ogre::SceneManager::PrefabType`[inherited]`

Prefab shapes available without loading a model.

Note:
  Minimal implementation at present.

Enumeration values:

  PT_PLANE |
  PT_CUBE |
  PT_SPHERE |

Definition at line 1080 of file OgreSceneManager.h.

enum Ogre::SceneManager::SpecialCaseRenderQueueMode`[inherited]`

Enumeration of the possible modes allowed for processing the special case render queue list.

See also:
  SceneManager::setSpecialCaseRenderQueueMode

Enumeration values:

  SCRQM_INCLUDE | Render only the queues in the special case list.
  SCRQM_EXCLUDE | Render all except the queues in the special case list.

Definition at line 260 of file OgreSceneManager.h.

## Constructor & Destructor Documentation

Ogre::DefaultSceneManager::DefaultSceneManager | ( | const String & | name | ) |

Ogre::DefaultSceneManager::~DefaultSceneManager | ( |  | ) |

## Member Function Documentation

virtual void Ogre::SceneManager::_applySceneAnimations | ( | void |  | ) | `[virtual, inherited]`

Internal method for applying animations to scene nodes.

Remarks:
  Uses the internally stored AnimationState objects to apply animation to SceneNodes.

virtual bool Ogre::SceneManager::_areRenderStateChangesSuppressed | ( | void |  | ) | const`[virtual, inherited]`

Are render state changes suppressed?

See also:
  _suppressRenderStateChanges

Definition at line 2671 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::_areShadowsSuppressed | ( | void |  | ) | const`[virtual, inherited]`

Are shadows suppressed?

See also:
  _suppressShadows

Definition at line 2704 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::_findVisibleObjects | ( | Camera * | cam,
|  | VisibleObjectsBoundsInfo * | visibleBounds,
|  | bool | onlyShadowCasters
| ) | `[virtual, inherited]`

Internal method which parses the scene to find visible objects to render.

Remarks:
  If you're implementing a custom scene manager, this is the most important method to override since it's here you can apply your custom world partitioning scheme. Once you have added the appropriate objects to the render queue, you can let the default SceneManager objects _renderVisibleObjects handle the actual rendering of the objects you pick.

  Any visible objects will be added to a rendering queue, which is indexed by material in order to ensure objects with the same material are rendered together to minimise render state changes.

uint32 Ogre::SceneManager::_getCombinedVisibilityMask | ( | void |  | ) | const`[inherited]`

| Internal method for getting the combination between the global visibility mask and the per-viewport visibility mask.

virtual const LightList& Ogre::SceneManager::_getLightsAffectingFrustum | ( | void |  | ) | const`[virtual, inherited]`

Get the list of lights which could be affecting the frustum.

Remarks:
  Note that default implementation of this method returns a cached light list, which is populated when rendering the scene. So by default the list of lights is only available during scene rendering.

ulong Ogre::SceneManager::_getLightsDirtyCounter | ( | void |  | ) | const`[inherited]`

Advance method to gets the lights dirty counter.

Remarks:
  Scene manager tracking lights that affecting the frustum, if changes detected (the changes includes light list itself and the light's position and attenuation range), then increase the lights dirty counter.

  When implementing customise lights finding algorithm relied on either SceneManager::_getLightsAffectingFrustum or SceneManager::_populateLightList, might check this value for sure that the light list are really need to re-populate, otherwise, returns cached light list (if exists) for better performance.

Definition at line 958 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::_injectRenderWithPass | ( | Pass * | pass,
|  | Renderable * | rend,
|  | bool | shadowDerivation = `true`
| ) | `[virtual, inherited]`

Render something as if it came from the current queue.

Parameters:

  | pass | Material pass to use for setting up this quad.
  | rend | Renderable to render
  | shadowDerivation | Whether passes should be replaced with shadow caster / receiver passes

virtual void Ogre::SceneManager::_notifyAutotrackingSceneNode | ( | SceneNode * | node,
|  | bool | autoTrack
| ) | `[virtual, inherited]`

| Internal method for notifying the manager that a SceneNode is autotracking.

virtual void Ogre::SceneManager::_notifyLightsDirty | ( | void |  | ) | `[virtual, inherited]`

Advance method to increase the lights dirty counter due lights changed.

Remarks:
  Scene manager tracking lights that affecting the frustum, if changes detected (the changes includes light list itself and the light's position and attenuation range), then increase the lights dirty counter.

  For some reason, you can call this method to force whole scene objects re-populate their light list. But near in mind, call to this method will harm performance, so should avoid if possible.

virtual void Ogre::SceneManager::_populateLightList | ( | const Vector3 & | position,
|  | Real | radius,
|  | LightList & | destList
| ) | `[virtual, inherited]`

Populate a light list with an ordered set of the lights which are closest to the position specified.

Remarks:
  Note that since directional lights have no position, they are always considered closer than any point lights and as such will always take precedence.

  Subclasses of the default SceneManager may wish to take into account other issues such as possible visibility of the light if that information is included in their data structures. This basic scenemanager simply orders by distance, eliminating those lights which are out of range or could not be affecting the frustum (i.e. only the lights returned by SceneManager::_getLightsAffectingFrustum are take into account).

  The number of items in the list max exceed the maximum number of lights supported by the renderer, but the extraneous ones will never be used. In fact the limit will be imposed by Pass::getMaxSimultaneousLights.

Parameters:

  | position | The position at which to evaluate the list of lights
  | radius | The bounding radius to test
  | destList | List to be populated with ordered set of lights; will be cleared by this method before population.

virtual void Ogre::SceneManager::_queueSkiesForRendering | ( | Camera * | cam | ) | `[virtual, inherited]`

| Internal method for queueing the sky objects with the params as previously set through setSkyBox, setSkyPlane and setSkyDome.

virtual void Ogre::SceneManager::_renderQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[virtual, inherited]`

Render the objects in a given queue group.

Remarks:
  You should only call this from a RenderQueueInvocation implementation

virtual void Ogre::SceneManager::_renderScene | ( | Camera * | camera,
|  | Viewport * | vp,
|  | bool | includeOverlays
| ) | `[virtual, inherited]`

Prompts the class to send its contents to the renderer.

Remarks:
  This method prompts the scene manager to send the contents of the scene it manages to the rendering pipeline, possibly preceded by some sorting, culling or other scene management tasks. Note that this method is not normally called directly by the user application; it is called automatically by the Ogre rendering loop.

Parameters:

  | camera | Pointer to a camera from whose viewpoint the scene is to be rendered.
  | vp | The target viewport
  | includeOverlays | Whether or not overlay objects should be rendered

virtual void Ogre::SceneManager::_renderVisibleObjects | ( | void |  | ) | `[virtual, inherited]`

| Sends visible objects found in _findVisibleObjects to the rendering engine.

virtual void Ogre::SceneManager::_setDestinationRenderSystem | ( | RenderSystem * | sys | ) | `[virtual, inherited]`

Notifies the scene manager of its destination render system.

Remarks:
  Called automatically by RenderSystem::addSceneManager this method simply notifies the manager of the render system to which its output must be directed.

Parameters:

  | sys | Pointer to the RenderSystem subclass to be used as a render target.

virtual const Pass* Ogre::SceneManager::_setPass | ( | const Pass * | pass,
|  | bool | evenIfSuppressed = `false`,
|  | bool | shadowDerivation = `true`
| ) | `[virtual, inherited]`

Internal method for setting up the renderstate for a rendering pass.

Parameters:

  | pass | The Pass details to set.
  | evenIfSuppressed | Sets the pass details even if render state changes are suppressed; if you are using this to manually set state when render state changes are suppressed, you should set this to true.
  | shadowDerivation | If false, disables the derivation of shadow passes from original passes

Returns:
  A Pass object that was used instead of the one passed in, can happen when rendering shadow passes

virtual void Ogre::SceneManager::_suppressRenderStateChanges | ( | bool | suppress | ) | `[virtual, inherited]`

Indicates to the SceneManager whether it should suppress changing the RenderSystem states when rendering objects.

Remarks:
  This method allows you to tell the SceneManager not to change any RenderSystem state until you tell it to. This method is only intended for advanced use, don't use it if you're unsure of the effect. The only RenderSystems calls made are to set the world matrix for each object (note - view an projection matrices are NOT SET - they are under your control) and to render the object; it is up to the caller to do everything else, including enabling any vertex / fragment programs and updating their parameter state, and binding parameters to the RenderSystem.

Note:
  Calling this implicitly disables shadow processing since no shadows can be rendered without changing state.

Parameters:

  | suppress | If true, no RenderSystem state changes will be issued until this method is called again with a parameter of false.

virtual void Ogre::SceneManager::_suppressShadows | ( | bool | suppress | ) | `[virtual, inherited]`

Indicates to the SceneManager whether it should suppress the active shadow rendering technique until told otherwise.

Remarks:
  This is a temporary alternative to setShadowTechnique to suppress the rendering of shadows and forcing all processing down the standard rendering path. This is intended for internal use only.

Parameters:

  | suppress | If true, no shadow rendering will occur until this method is called again with a parameter of false.

virtual void Ogre::SceneManager::_updateSceneGraph | ( | Camera * | cam | ) | `[virtual, inherited]`

Internal method for updating the scene graph ie the tree of SceneNode instances managed by this class.

Remarks:
  This must be done before issuing objects to the rendering pipeline, since derived transformations from parent nodes are not updated until required. This SceneManager is a basic implementation which simply updates all nodes from the root. This ensures the scene is up to date but requires all the nodes to be updated even if they are not visible. Subclasses could trim this such that only potentially visible nodes are updated.

virtual void Ogre::SceneManager::addRenderQueueListener | ( | RenderQueueListener * | newListener | ) | `[virtual, inherited]`

| Registers a new RenderQueueListener which will be notified when render queues are processed.

virtual void Ogre::SceneManager::addShadowListener | ( | ShadowListener * | s | ) | `[virtual, inherited]`

| Add a shadow listener which will get called back on shadow events.

virtual void Ogre::SceneManager::addSpecialCaseRenderQueue | ( | uint8 | qid | ) | `[virtual, inherited]`

Adds an item to the 'special case' render queue list.

Remarks:
  Normally all render queues are rendered, in their usual sequence, only varying if a RenderQueueListener nominates for the queue to be repeated or skipped. This method allows you to add a render queue to a 'special case' list, which varies the behaviour. The effect of this list depends on the 'mode' in which this list is in, which might be to exclude these render queues, or to include them alone (excluding all other queues). This allows you to perform broad selective rendering without requiring a RenderQueueListener.

Parameters:

  | qid | The identifier of the queue which should be added to the special case list. Nothing happens if the queue is already in the list.

virtual void Ogre::SceneManager::clearScene | ( | void |  | ) | `[virtual, inherited]`

| Empties the entire scene, inluding all SceneNodes, Entities, Lights, BillboardSets etc. Cameras are not deleted at this stage since they are still referenced by viewports, which are not destroyed during this process.

virtual void Ogre::SceneManager::clearSpecialCaseRenderQueues | ( | void |  | ) | `[virtual, inherited]`

Clears the 'special case' render queue list.

See also:
  SceneManager::addSpecialCaseRenderQueue

virtual AxisAlignedBoxSceneQuery* Ogre::SceneManager::createAABBQuery | ( | const AxisAlignedBox & | box,
|  | unsigned long | mask = `0xFFFFFFFF`
| ) | `[virtual, inherited]`

Creates an AxisAlignedBoxSceneQuery for this scene manager.

Remarks:
  This method creates a new instance of a query object for this scene manager, for an axis aligned box region. See SceneQuery and AxisAlignedBoxSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters:

  | box | Details of the box which describes the region for this query.
  | mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

virtual Animation* Ogre::SceneManager::createAnimation | ( | const String & | name,
|  | Real | length
| ) | `[virtual, inherited]`

Creates an animation which can be used to animate scene nodes.

Remarks:
  An animation is a collection of 'tracks' which over time change the position / orientation of Node objects. In this case, the animation will likely have tracks to modify the position / orientation of SceneNode objects, e.g. to make objects move along a path.

  You don't need to use an Animation object to move objects around - you can do it yourself using the methods of the Node in your FrameListener class. However, when you need relatively complex scripted animation, this is the class to use since it will interpolate between keyframes for you and generally make the whole process easier to manage.

  A single animation can affect multiple Node objects (each AnimationTrack affects a single Node). In addition, through animation blending a single Node can be affected by multiple animations, athough this is more useful when performing skeletal animation (see Skeleton::createAnimation).

  Note that whilst it uses the same classes, the animations created here are kept separate from the skeletal animations of meshes (each Skeleton owns those animations).

Parameters:

  | name | The name of the animation, must be unique within this SceneManager.
  | length | The total length of the animation.

virtual AnimationState* Ogre::SceneManager::createAnimationState | ( | const String & | animName | ) | `[virtual, inherited]`

Create an AnimationState object for managing application of animations.

Remarks:
  You can create Animation objects for animating SceneNode obejcts using the createAnimation method. However, in order to actually apply those animations you have to call methods on Node and Animation in a particular order (namely Node::resetToInitialState and Animation::apply). To make this easier and to help track the current time position of animations, the AnimationState object is provided. So if you don't want to control animation application manually, call this method, update the returned object as you like every frame and let SceneManager apply the animation state for you.

  Remember, AnimationState objects are disabled by default at creation time. Turn them on when you want them using their setEnabled method.

  Note that any SceneNode affected by this automatic animation will have it's state reset to it's initial position before application of the animation. Unless specifically modified using Node::setInitialState the Node assumes it's initial state is at the origin. If you want the base state of the SceneNode to be elsewhere, make your changes to the node using the standard transform methods, then call setInitialState to 'bake' this reference position into the node.

  If the target of your animation is to be a generic AnimableValue, you should ensure that it has a base value set (unlike nodes this has no default).

See also:
  AnimableValue::setAsBaseValue.

Parameters:

  | animName | The name of an animation created already with createAnimation.

virtual BillboardChain* Ogre::SceneManager::createBillboardChain | ( | const String & | name | ) | `[virtual, inherited]`

Create a BillboardChain, an object which you can use to render a linked chain of billboards.

Parameters:

  | name | The name to be given to the object (must be unique).

virtual BillboardSet* Ogre::SceneManager::createBillboardSet | ( | const String & | name,
|  | unsigned int | poolSize = `20`
| ) | `[virtual, inherited]`

Creates a new BillboardSet for use with this scene manager.

Remarks:
  This method creates a new BillboardSet which is registered with the SceneManager. The SceneManager will destroy this object when it shuts down or when the SceneManager::clearScene method is called, so the caller does not have to worry about destroying this object (in fact, it definitely should not do this).

  See the BillboardSet documentations for full details of the returned class.

Parameters:

  | name | The name to give to this billboard set. Must be unique.
  | poolSize | The initial size of the pool of billboards (see BillboardSet for more information)

See also:
  BillboardSet

virtual Camera* Ogre::SceneManager::createCamera | ( | const String & | name | ) | `[virtual, inherited]`

Creates a camera to be managed by this scene manager.

Remarks:
  This camera must be added to the scene at a later time using the attachObject method of the SceneNode class.

Parameters:

  | name | Name to give the new camera.

virtual Entity* Ogre::SceneManager::createEntity | ( | const String & | entityName,
|  | PrefabType | ptype
| ) | `[virtual, inherited]`

Create an Entity (instance of a discrete mesh) from a range of prefab shapes.

Parameters:

  | entityName | The name to be given to the entity (must be unique).
  | ptype | The prefab type.

virtual Entity* Ogre::SceneManager::createEntity | ( | const String & | entityName,
|  | const String & | meshName
| ) | `[virtual, inherited]`

Create an Entity (instance of a discrete mesh).

Parameters:

  | entityName | The name to be given to the entity (must be unique).
  | meshName | The name of the Mesh it is to be based on (e.g. 'knot.oof'). The mesh will be loaded if it is not already.

virtual InstancedGeometry* Ogre::SceneManager::createInstancedGeometry | ( | const String & | name | ) | `[virtual, inherited]`

Creates a InstancedGeometry instance suitable for use with this SceneManager.

Remarks:
  InstancedGeometry is a way of batching up geometry into a more efficient form, and still be able to move it. Please read the InstancedGeometry class documentation for full information.

Parameters:

  | name | The name to give the new object

Returns:
  The new InstancedGeometry instance

virtual IntersectionSceneQuery* Ogre::SceneManager::createIntersectionQuery | ( | unsigned long | mask = `0xFFFFFFFF` | ) | `[virtual, inherited]`

Creates an IntersectionSceneQuery for this scene manager.

Remarks:
  This method creates a new instance of a query object for locating intersecting objects. See SceneQuery and IntersectionSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters:

  | mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

virtual Light* Ogre::SceneManager::createLight | ( | const String & | name | ) | `[virtual, inherited]`

Creates a light for use in the scene.

Remarks:
  Lights can either be in a fixed position and independent of the scene graph, or they can be attached to SceneNodes so they derive their position from the parent node. Either way, they are created using this method so that the SceneManager manages their existence.

Parameters:

  | name | The name of the new light, to identify it later.

virtual ManualObject* Ogre::SceneManager::createManualObject | ( | const String & | name | ) | `[virtual, inherited]`

Create a ManualObject, an object which you populate with geometry manually through a GL immediate-mode style interface.

Parameters:

  | name | The name to be given to the object (must be unique).

virtual MovableObject* Ogre::SceneManager::createMovableObject | ( | const String & | name,
|  | const String & | typeName,
|  | const NameValuePairList * | params = `0`
| ) | `[virtual, inherited]`

Create a movable object of the type specified.

Remarks:
  This is the generalised form of MovableObject creation where you can create a MovableObject of any specialised type generically, including any new types registered using plugins.

Parameters:

  | name | The name to give the object. Must be unique within type.
  | typeName | The type of object to create
  | params | Optional name/value pair list to give extra parameters to the created object.

virtual ParticleSystem* Ogre::SceneManager::createParticleSystem | ( | const String & | name,
|  | size_t | quota = `500`,
|  | const String & | resourceGroup = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[virtual, inherited]`

Create a blank particle system.

Remarks:
  This method creates a new, blank ParticleSystem instance and returns a pointer to it. The caller should not delete this object, it will be freed at system shutdown, or can be released earlier using the destroyParticleSystem method.

  The instance returned from this method won't actually do anything because on creation a particle system has no emitters. The caller should manipulate the instance through it's ParticleSystem methods to actually create a real particle effect.

  Creating a particle system does not make it a part of the scene. As with other MovableObject subclasses, a ParticleSystem is not rendered until it is attached to a SceneNode.

Parameters:

  | name | The name to give the ParticleSystem.
  | quota | The maximum number of particles to allow in this system.
  | resourceGroup | The resource group which will be used to load dependent resources

virtual ParticleSystem* Ogre::SceneManager::createParticleSystem | ( | const String & | name,
|  | const String & | templateName
| ) | `[virtual, inherited]`

Creates a particle system based on a template.

Remarks:
  This method creates a new ParticleSystem instance based on the named template (defined through ParticleSystemManager::createTemplate) and returns a pointer to the caller. The caller should not delete this object, it will be freed at system shutdown, or can be released earlier using the destroyParticleSystem method.

  Each system created from a template takes the template's settings at the time of creation, but is completely separate from the template from there on.

  Creating a particle system does not make it a part of the scene. As with other MovableObject subclasses, a ParticleSystem is not rendered until it is attached to a SceneNode.

  This is probably the more useful particle system creation method since it does not require manual setup of the system. Note that the initial quota is based on the template but may be changed later.

Parameters:

  | name | The name to give the new particle system instance.
  | templateName | The name of the template to base the new instance on.

virtual PlaneBoundedVolumeListSceneQuery* Ogre::SceneManager::createPlaneBoundedVolumeQuery | ( | const PlaneBoundedVolumeList & | volumes,
|  | unsigned long | mask = `0xFFFFFFFF`
| ) | `[virtual, inherited]`

Creates a PlaneBoundedVolumeListSceneQuery for this scene manager.

Remarks:
  This method creates a new instance of a query object for this scene manager, for a region enclosed by a set of planes (normals pointing inwards). See SceneQuery and PlaneBoundedVolumeListSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters:

  | volumes | Details of the volumes which describe the region for this query.
  | mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

virtual RaySceneQuery* Ogre::SceneManager::createRayQuery | ( | const Ray & | ray,
|  | unsigned long | mask = `0xFFFFFFFF`
| ) | `[virtual, inherited]`

Creates a RaySceneQuery for this scene manager.

Remarks:
  This method creates a new instance of a query object for this scene manager, looking for objects which fall along a ray. See SceneQuery and RaySceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters:

  | ray | Details of the ray which describes the region for this query.
  | mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

virtual RibbonTrail* Ogre::SceneManager::createRibbonTrail | ( | const String & | name | ) | `[virtual, inherited]`

Create a RibbonTrail, an object which you can use to render a linked chain of billboards which follows one or more nodes.

Parameters:

  | name | The name to be given to the object (must be unique).

virtual SceneNode* Ogre::SceneManager::createSceneNode | ( | const String & | name | ) | `[virtual, inherited]`

Creates an instance of a SceneNode with a given name.

Remarks:
  Note that this does not add the SceneNode to the scene hierarchy. This method is for convenience, since it allows an instance to be created for which the SceneManager is responsible for allocating and releasing memory, which is convenient in complex scenes.

  To include the returned SceneNode in the scene, use the addChild method of the SceneNode which is to be it's parent.

  Note that this method takes a name parameter, which makes the node easier to retrieve directly again later.

virtual SceneNode* Ogre::SceneManager::createSceneNode | ( | void |  | ) | `[virtual, inherited]`

Creates an instance of a SceneNode.

Remarks:
  Note that this does not add the SceneNode to the scene hierarchy. This method is for convenience, since it allows an instance to be created for which the SceneManager is responsible for allocating and releasing memory, which is convenient in complex scenes.

  To include the returned SceneNode in the scene, use the addChild method of the SceneNode which is to be it's parent.

  Note that this method takes no parameters, and the node created is unnamed (it is actually given a generated name, which you can retrieve if you want). If you wish to create a node with a specific name, call the alternative method which takes a name parameter.

virtual MeshPtr Ogre::SceneManager::createSkyboxPlane | ( | BoxPlane | bp,
|  | Real | distance,
|  | const Quaternion & | orientation,
|  | const String & | groupName
| ) | `[protected, virtual, inherited]`

virtual MeshPtr Ogre::SceneManager::createSkydomePlane | ( | BoxPlane | bp,
|  | Real | curvature,
|  | Real | tiling,
|  | Real | distance,
|  | const Quaternion & | orientation,
|  | int | xsegments,
|  | int | ysegments,
|  | int | ySegmentsToKeep,
|  | const String & | groupName
| ) | `[protected, virtual, inherited]`

virtual SphereSceneQuery* Ogre::SceneManager::createSphereQuery | ( | const Sphere & | sphere,
|  | unsigned long | mask = `0xFFFFFFFF`
| ) | `[virtual, inherited]`

Creates a SphereSceneQuery for this scene manager.

Remarks:
  This method creates a new instance of a query object for this scene manager, for a spherical region. See SceneQuery and SphereSceneQuery for full details.

  The instance returned from this method must be destroyed by calling SceneManager::destroyQuery when it is no longer required.

Parameters:

  | sphere | Details of the sphere which describes the region for this query.
  | mask | The query mask to apply to this query; can be used to filter out certain objects; see SceneQuery for details.

virtual StaticGeometry* Ogre::SceneManager::createStaticGeometry | ( | const String & | name | ) | `[virtual, inherited]`

Creates a StaticGeometry instance suitable for use with this SceneManager.

Remarks:
  StaticGeometry is a way of batching up geometry into a more efficient form at the expense of being able to move it. Please read the StaticGeometry class documentation for full information.

Parameters:

  | name | The name to give the new object

Returns:
  The new StaticGeometry instance

virtual const Pass* Ogre::SceneManager::deriveShadowCasterPass | ( | const Pass * | pass | ) | `[protected, virtual, inherited]`

Internal method for turning a regular pass into a shadow caster pass.

Remarks:
  This is only used for texture shadows, basically we're trying to ensure that objects are rendered solid black. This method will usually return the standard solid black pass for all fixed function passes, but will merge in a vertex program and fudge the AutpoParamDataSource to set black lighting for passes with vertex programs.

virtual const Pass* Ogre::SceneManager::deriveShadowReceiverPass | ( | const Pass * | pass | ) | `[protected, virtual, inherited]`

Internal method for turning a regular pass into a shadow receiver pass.

Remarks:
  This is only used for texture shadows, basically we're trying to ensure that objects are rendered with a projective texture. This method will usually return a standard single-texture pass for all fixed function passes, but will merge in a vertex program for passes with vertex programs.

virtual void Ogre::SceneManager::destroyAllAnimations | ( | void |  | ) | `[virtual, inherited]`

| Removes all animations created using this SceneManager.

virtual void Ogre::SceneManager::destroyAllAnimationStates | ( | void |  | ) | `[virtual, inherited]`

| Removes all animation states created using this SceneManager.

virtual void Ogre::SceneManager::destroyAllBillboardChains | ( | void |  | ) | `[virtual, inherited]`

| Removes & destroys all BillboardChains from the SceneManager.

virtual void Ogre::SceneManager::destroyAllBillboardSets | ( | void |  | ) | `[virtual, inherited]`

Removes & destroys all BillboardSets.

Warning:
  Again, use caution since no BillboardSet must be referred to elsewhere e.g. attached to a SceneNode otherwise a crash is likely. Use clearScene if you are unsure (it clears SceneNode entries too.)

See also:
  SceneManager::clearScene

virtual void Ogre::SceneManager::destroyAllCameras | ( | void |  | ) | `[virtual, inherited]`

Removes (and destroys) all cameras from the scene.

Remarks:
  Some cameras are internal created to dealing with texture shadow, their aren't supposed to destroy outside. So, while you are using texture shadow, don't call this method, or you can set the shadow technique other than texture-based, which will destroy all internal created shadow cameras and textures.

virtual void Ogre::SceneManager::destroyAllEntities | ( | void |  | ) | `[virtual, inherited]`

Removes & destroys all Entities.

Warning:
  Again, use caution since no Entity must be referred to elsewhere e.g. attached to a SceneNode otherwise a crash is likely. Use clearScene if you are unsure (it clears SceneNode entries too.)

See also:
  SceneManager::clearScene

virtual void Ogre::SceneManager::destroyAllInstancedGeometry | ( | void |  | ) | `[virtual, inherited]`

| Remove & destroy all InstancedGeometry instances.

virtual void Ogre::SceneManager::destroyAllLights | ( | void |  | ) | `[virtual, inherited]`

| Removes and destroys all lights in the scene.

virtual void Ogre::SceneManager::destroyAllManualObjects | ( | void |  | ) | `[virtual, inherited]`

| Removes & destroys all ManualObjects from the SceneManager.

virtual void Ogre::SceneManager::destroyAllMovableObjects | ( | void |  | ) | `[virtual, inherited]`

| Destroy all MovableObjects.

virtual void Ogre::SceneManager::destroyAllMovableObjectsByType | ( | const String & | typeName | ) | `[virtual, inherited]`

| Destroy all MovableObjects of a given type.

virtual void Ogre::SceneManager::destroyAllParticleSystems | ( | void |  | ) | `[virtual, inherited]`

| Removes & destroys all ParticleSystems from the SceneManager.

virtual void Ogre::SceneManager::destroyAllRibbonTrails | ( | void |  | ) | `[virtual, inherited]`

| Removes & destroys all RibbonTrails from the SceneManager.

virtual void Ogre::SceneManager::destroyAllStaticGeometry | ( | void |  | ) | `[virtual, inherited]`

| Remove & destroy all StaticGeometry instances.

virtual void Ogre::SceneManager::destroyAnimation | ( | const String & | name | ) | `[virtual, inherited]`

Destroys an Animation.

Remarks:
  You should ensure that none of your code is referencing this animation objects since the memory will be freed.

virtual void Ogre::SceneManager::destroyAnimationState | ( | const String & | name | ) | `[virtual, inherited]`

Destroys an AnimationState.

Remarks:
  You should ensure that none of your code is referencing this animation state object since the memory will be freed.

virtual void Ogre::SceneManager::destroyBillboardChain | ( | const String & | name | ) | `[virtual, inherited]`

| Removes & destroys a BillboardChain from the SceneManager.

virtual void Ogre::SceneManager::destroyBillboardChain | ( | BillboardChain * | obj | ) | `[virtual, inherited]`

| Removes & destroys a BillboardChain from the SceneManager.

virtual void Ogre::SceneManager::destroyBillboardSet | ( | const String & | name | ) | `[virtual, inherited]`

Removes & destroys an BillboardSet from the SceneManager by name.

Warning:
  Must only be done if the BillboardSet is not attached to a SceneNode. It may be safer to wait to clear the whole scene. If you are unsure, use clearScene.

virtual void Ogre::SceneManager::destroyBillboardSet | ( | BillboardSet * | set | ) | `[virtual, inherited]`

Removes & destroys an BillboardSet from the SceneManager.

Warning:
  Must only be done if the BillboardSet is not attached to a SceneNode. It may be safer to wait to clear the whole scene. If you are unsure, use clearScene.

virtual void Ogre::SceneManager::destroyCamera | ( | const String & | name | ) | `[virtual, inherited]`

Removes a camera from the scene.

Remarks:
  This method removes an camera from the scene based on the camera's name rather than a pointer.

virtual void Ogre::SceneManager::destroyCamera | ( | Camera * | cam | ) | `[virtual, inherited]`

Removes a camera from the scene.

Remarks:
  This method removes a previously added camera from the scene. The camera is deleted so the caller must ensure no references to it's previous instance (e.g. in a SceneNode) are used.

Parameters:

  | cam | Pointer to the camera to remove

virtual void Ogre::SceneManager::destroyEntity | ( | const String & | name | ) | `[virtual, inherited]`

Removes & destroys an Entity from the SceneManager by name.

Warning:
  Must only be done if the Entity is not attached to a SceneNode. It may be safer to wait to clear the whole scene if you are unsure use clearScene.

See also:
  SceneManager::clearScene

virtual void Ogre::SceneManager::destroyEntity | ( | Entity * | ent | ) | `[virtual, inherited]`

Removes & destroys an Entity from the SceneManager.

Warning:
  Must only be done if the Entity is not attached to a SceneNode. It may be safer to wait to clear the whole scene if you are unsure use clearScene.

See also:
  SceneManager::clearScene

virtual void Ogre::SceneManager::destroyInstancedGeometry | ( | const String & | name | ) | `[virtual, inherited]`

| Remove & destroy a InstancedGeometry instance.

virtual void Ogre::SceneManager::destroyInstancedGeometry | ( | InstancedGeometry * | geom | ) | `[virtual, inherited]`

| Remove & destroy a InstancedGeometry instance.

virtual void Ogre::SceneManager::destroyLight | ( | Light * | light | ) | `[virtual, inherited]`

Removes the light from the scene and destroys it based on a pointer.

Remarks:
  Any pointers held to this light after calling this method will be invalid.

virtual void Ogre::SceneManager::destroyLight | ( | const String & | name | ) | `[virtual, inherited]`

Removes the named light from the scene and destroys it.

Remarks:
  Any pointers held to this light after calling this method will be invalid.

virtual void Ogre::SceneManager::destroyManualObject | ( | const String & | name | ) | `[virtual, inherited]`

| Removes & destroys a ManualObject from the SceneManager.

virtual void Ogre::SceneManager::destroyManualObject | ( | ManualObject * | obj | ) | `[virtual, inherited]`

| Removes & destroys a ManualObject from the SceneManager.

virtual void Ogre::SceneManager::destroyMovableObject | ( | MovableObject * | m | ) | `[virtual, inherited]`

Destroys a MovableObject.

Remarks:
  The MovableObject will automatically detach itself from any nodes on destruction.

virtual void Ogre::SceneManager::destroyMovableObject | ( | const String & | name,
|  | const String & | typeName
| ) | `[virtual, inherited]`

Destroys a MovableObject with the name specified, of the type specified.

Remarks:
  The MovableObject will automatically detach itself from any nodes on destruction.

virtual void Ogre::SceneManager::destroyParticleSystem | ( | const String & | name | ) | `[virtual, inherited]`

| Removes & destroys a ParticleSystem from the SceneManager.

virtual void Ogre::SceneManager::destroyParticleSystem | ( | ParticleSystem * | obj | ) | `[virtual, inherited]`

| Removes & destroys a ParticleSystem from the SceneManager.

virtual void Ogre::SceneManager::destroyQuery | ( | SceneQuery * | query | ) | `[virtual, inherited]`

| Destroys a scene query of any type.

virtual void Ogre::SceneManager::destroyRibbonTrail | ( | const String & | name | ) | `[virtual, inherited]`

| Removes & destroys a RibbonTrail from the SceneManager.

virtual void Ogre::SceneManager::destroyRibbonTrail | ( | RibbonTrail * | obj | ) | `[virtual, inherited]`

| Removes & destroys a RibbonTrail from the SceneManager.

virtual void Ogre::SceneManager::destroySceneNode | ( | const String & | name | ) | `[virtual, inherited]`

Destroys a SceneNode with a given name.

Remarks:
  This allows you to physically delete an individual SceneNode if you want to. Note that this is not normally recommended, it's better to allow SceneManager to delete the nodes when the scene is cleared.

virtual void Ogre::SceneManager::destroyShadowTextures | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for destroying shadow textures (texture-based shadows).

virtual void Ogre::SceneManager::destroyStaticGeometry | ( | const String & | name | ) | `[virtual, inherited]`

| Remove & destroy a StaticGeometry instance.

virtual void Ogre::SceneManager::destroyStaticGeometry | ( | StaticGeometry * | geom | ) | `[virtual, inherited]`

| Remove & destroy a StaticGeometry instance.

virtual void Ogre::SceneManager::ensureShadowTexturesCreated | ( |  | ) | `[protected, virtual, inherited]`

| Internal method for creating shadow textures (texture-based shadows).

virtual size_t Ogre::SceneManager::estimateWorldGeometry | ( | DataStreamPtr & | stream,
|  | const String & | typeName = `StringUtil::BLANK`
| ) | `[virtual, inherited]`

Estimate the number of loading stages required to load the named world geometry.

Remarks:
  Operates just like the version of this method which takes a filename, but operates on a stream instead. Note that since the stream is updated, you'll need to reset the stream or reopen it when it comes to loading it for real.

Parameters:

  | stream | Data stream containing data to load
  | typeName | String identifying the type of world geometry contained in the stream - not required if this manager only supports one type of world geometry.

Definition at line 1347 of file OgreSceneManager.h.

virtual size_t Ogre::SceneManager::estimateWorldGeometry | ( | const String & | filename | ) | `[virtual, inherited]`

Estimate the number of loading stages required to load the named world geometry.

Remarks:
  This method should be overridden by SceneManagers that provide custom world geometry that can take some time to load. They should return from this method a count of the number of stages of progress they can report on whilst loading. During real loading (setWorldGeomtry), they should call ResourceGroupManager::_notifyWorldGeometryProgress exactly that number of times when loading the geometry for real.

Note:
  The default is to return 0, ie to not report progress.

Definition at line 1333 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::extractAllMovableObjectsByType | ( | const String & | typeName | ) | `[virtual, inherited]`

Extract all injected MovableObjects of a given type.

Remarks:
  Essentially this does the same as destroyAllMovableObjectsByType, but only removes the instances from the internal lists, it does not attempt to destroy them.

virtual void Ogre::SceneManager::extractMovableObject | ( | MovableObject * | m | ) | `[virtual, inherited]`

Extract a previously injected MovableObject.

Remarks:
  Essentially this does the same as destroyMovableObject, but only removes the instance from the internal lists, it does not attempt to destroy it.

virtual void Ogre::SceneManager::extractMovableObject | ( | const String & | name,
|  | const String & | typeName
| ) | `[virtual, inherited]`

Extract a previously injected MovableObject.

Remarks:
  Essentially this does the same as destroyMovableObject, but only removes the instance from the internal lists, it does not attempt to destroy it.

virtual void Ogre::SceneManager::findLightsAffectingFrustum | ( | const Camera * | camera | ) | `[protected, virtual, inherited]`

Internal method for locating a list of lights which could be affecting the frustum.

Remarks:
  Custom scene managers are encouraged to override this method to make use of their scene partitioning scheme to more efficiently locate lights, and to eliminate lights which may be occluded by word geometry.

virtual const ShadowCasterList& Ogre::SceneManager::findShadowCastersForLight | ( | const Light * | light,
|  | const Camera * | camera
| ) | `[protected, virtual, inherited]`

Internal method for locating a list of shadow casters which could be affecting the frustum for a given light.

Remarks:
  Custom scene managers are encouraged to override this method to add optimisations, and to add their own custom shadow casters (perhaps for world geometry)

virtual bool Ogre::SceneManager::fireRenderQueueEnded | ( | uint8 | id,
|  | const String & | invocation
| ) | `[protected, virtual, inherited]`

| Internal method for firing the queue end event, returns true if queue is to be repeated.

virtual bool Ogre::SceneManager::fireRenderQueueStarted | ( | uint8 | id,
|  | const String & | invocation
| ) | `[protected, virtual, inherited]`

| Internal method for firing the queue start event, returns true if queue is to be skipped.

virtual void Ogre::SceneManager::fireShadowTexturesPreCaster | ( | Light * | light,
|  | Camera * | camera
| ) | `[protected, virtual, inherited]`

| Internal method for firing the pre caster texture shadows event.

virtual void Ogre::SceneManager::fireShadowTexturesPreReceiver | ( | Light * | light,
|  | Frustum * | f
| ) | `[protected, virtual, inherited]`

| Internal method for firing the pre receiver texture shadows event.

virtual void Ogre::SceneManager::fireShadowTexturesUpdated | ( | size_t | numberOfShadowTextures | ) | `[protected, virtual, inherited]`

| Internal method for firing the texture shadows updated event.

const ColourValue& Ogre::SceneManager::getAmbientLight | ( | void |  | ) | const`[inherited]`

| Returns the ambient light level to be used for the scene.

virtual Animation* Ogre::SceneManager::getAnimation | ( | const String & | name | ) | const`[virtual, inherited]`

Looks up an Animation object previously created with createAnimation.

Note:
  Throws an exception if the named instance does not exist

AnimationIterator Ogre::SceneManager::getAnimationIterator | ( | void |  | ) | `[inherited]`

| Returns a specialised MapIterator over all animations in the scene. Definition at line 2098 of file OgreSceneManager.h.

virtual AnimationState* Ogre::SceneManager::getAnimationState | ( | const String & | animName | ) | const`[virtual, inherited]`

Retrieves animation state as previously created using createAnimationState.

Note:
  Throws an exception if the named instance does not exist

AnimationStateIterator Ogre::SceneManager::getAnimationStateIterator | ( | void |  | ) | `[inherited]`

| Returns a specialised MapIterator over all animation states in the scene. Definition at line 2102 of file OgreSceneManager.h.

virtual BillboardChain* Ogre::SceneManager::getBillboardChain | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named BillboardChain.

Note:
  Throws an exception if the named instance does not exist

virtual BillboardSet* Ogre::SceneManager::getBillboardSet | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named BillboardSet.

Note:
  Throws an exception if the named instance does not exist

virtual Camera* Ogre::SceneManager::getCamera | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named camera.

Note:
  Throws an exception if the named instance does not exist

CameraIterator Ogre::SceneManager::getCameraIterator | ( | void |  | ) | `[inherited]`

| Returns a specialised MapIterator over all cameras in the scene. Definition at line 2094 of file OgreSceneManager.h.

Viewport* Ogre::SceneManager::getCurrentViewport | ( | void |  | ) | const`[inherited]`

| Gets the current viewport being rendered (advanced use only, only valid during viewport update. Definition at line 2741 of file OgreSceneManager.h.

RenderSystem* Ogre::SceneManager::getDestinationRenderSystem | ( |  | ) | `[inherited]`

| Get the rendersystem subclass to which the output of this Scene Manager gets sent.

virtual bool Ogre::SceneManager::getDisplaySceneNodes | ( | void |  | ) | const`[virtual, inherited]`

| Returns true if all scene nodes axis are to be displayed. Definition at line 1800 of file OgreSceneManager.h.

virtual Entity* Ogre::SceneManager::getEntity | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named Entity.

Note:
  Throws an exception if the named instance does not exist

virtual bool Ogre::SceneManager::getFindVisibleObjects | ( | void |  | ) | `[virtual, inherited]`

| Gets whether the SceneManager should search for visible objects, or whether they are being manually handled. Definition at line 2639 of file OgreSceneManager.h.

virtual const ColourValue& Ogre::SceneManager::getFogColour | ( | void |  | ) | const`[virtual, inherited]`

| Returns the fog colour for the scene.

virtual Real Ogre::SceneManager::getFogDensity | ( | void |  | ) | const`[virtual, inherited]`

| Returns the fog density for the scene.

virtual Real Ogre::SceneManager::getFogEnd | ( | void |  | ) | const`[virtual, inherited]`

| Returns the fog end distance for the scene.

virtual FogMode Ogre::SceneManager::getFogMode | ( | void |  | ) | const`[virtual, inherited]`

| Returns the fog mode for the scene.

virtual Real Ogre::SceneManager::getFogStart | ( | void |  | ) | const`[virtual, inherited]`

| Returns the fog start distance for the scene.

virtual InstancedGeometry* Ogre::SceneManager::getInstancedGeometry | ( | const String & | name | ) | const`[virtual, inherited]`

| Retrieve a previously created InstancedGeometry instance.

virtual Light* Ogre::SceneManager::getLight | ( | const String & | name | ) | const`[virtual, inherited]`

Returns a pointer to the named Light which has previously been added to the scene.

Note:
  Throws an exception if the named instance does not exist

virtual ManualObject* Ogre::SceneManager::getManualObject | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named ManualObject.

Note:
  Throws an exception if the named instance does not exist

virtual MovableObject* Ogre::SceneManager::getMovableObject | ( | const String & | name,
|  | const String & | typeName
| ) | const`[virtual, inherited]`

Get a reference to a previously created MovableObject.

Note:
  Throws an exception if the named instance does not exist

const MovableObjectCollection* Ogre::SceneManager::getMovableObjectCollection | ( | const String & | typeName | ) | const`[protected, inherited]`

Gets the movable object collection for the given type name.

Remarks:
  This method throw exception if the collection does not exist.

MovableObjectCollection* Ogre::SceneManager::getMovableObjectCollection | ( | const String & | typeName | ) | `[protected, inherited]`

Gets the movable object collection for the given type name.

Remarks:
  This method create new collection if the collection does not exist.

virtual MovableObjectIterator Ogre::SceneManager::getMovableObjectIterator | ( | const String & | typeName | ) | `[virtual, inherited]`

Get an iterator over all MovableObect instances of a given type.

Note:
  The iterator returned from this method is not thread safe, do not use this if you are creating or deleting objects of this type in another thread.

const String& Ogre::SceneManager::getName | ( | void |  | ) | const`[inherited]`

| Return the instance name of this SceneManager. Definition at line 843 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::getOption | ( | const String & | strKey,
|  | void * | pDestValue
| ) | `[virtual, inherited]`

Method for getting the value of an implementation-specific Scene Manager option.

Parameters:

  | strKey | The name of the option
  | pDestValue | A pointer to a memory location where the value will be copied. Currently, the memory will be allocated by the scene manager, but this may change

Returns:
  On success, true is returned and pDestValue points to the value of the given option.

  On failiure, false is returned and pDestValue is set to NULL.

Definition at line 1393 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::getOptionKeys | ( | StringVector & | refKeys | ) | `[virtual, inherited]`

Method for getting all the implementation-specific options of the scene manager.

Parameters:

  | refKeys | A reference to a list that will be filled with all the available options.

Returns:
  On success, true is returned. On failiure, false is returned.

Definition at line 1427 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::getOptionValues | ( | const String & | strKey,
|  | StringVector & | refValueList
| ) | `[virtual, inherited]`

Method for getting all possible values for a specific option.

When this list is too large (i.e. the option expects, for example, a float), the return value will be true, but the list will contain just one element whose size will be set to 0. Otherwise, the list will be filled with all the possible values the option can accept.

Parameters:

  | strKey | The name of the option to get the values for.
  | refValueList | A reference to a list that will be filled with the available values.

Returns:
  On success (the option exists), true is returned.

  On failure, false is returned.

Definition at line 1419 of file OgreSceneManager.h.

virtual ParticleSystem* Ogre::SceneManager::getParticleSystem | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named ParticleSystem.

Note:
  Throws an exception if the named instance does not exist

SceneMgrQueuedRenderableVisitor* Ogre::SceneManager::getQueuedRenderableVisitor | ( | void |  | ) | const`[inherited]`

| Gets the current visitor object which processes queued renderables.

virtual RenderQueue* Ogre::SceneManager::getRenderQueue | ( | void |  | ) | `[virtual, inherited]`

Retrieves the internal render queue, for advanced users only.

Remarks:
  The render queue is mainly used internally to manage the scene object rendering queue, it also exports some methods to allow advanced users to configure the behavior of rendering process. Most methods provided by RenderQueue are supposed to be used internally only, you should reference to the RenderQueue API for more information. Do not access this directly unless you know what you are doing.

virtual RibbonTrail* Ogre::SceneManager::getRibbonTrail | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a pointer to the named RibbonTrail.

Note:
  Throws an exception if the named instance does not exist

virtual SceneNode* Ogre::SceneManager::getRootSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Gets the SceneNode at the root of the scene hierarchy.

Remarks:
  The entire scene is held as a hierarchy of nodes, which allows things like relative transforms, general changes in rendering state etc (See the SceneNode class for more info). In this basic SceneManager class, the application using Ogre is free to structure this hierarchy however it likes, since it has no real significance apart from making transforms relative to each node (more specialised subclasses will provide utility methods for building specific node structures e.g. loading a BSP tree).

  However, in all cases there is only ever one root node of the hierarchy, and this method returns a pointer to it.

virtual SceneNode* Ogre::SceneManager::getSceneNode | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieves a named SceneNode from the scene graph.

Remarks:
  If you chose to name a SceneNode as you created it, or if you happened to make a note of the generated name, you can look it up wherever it is in the scene graph using this method.

Note:
  Throws an exception if the named instance does not exist

virtual const ShadowCameraSetupPtr& Ogre::SceneManager::getShadowCameraSetup | ( |  | ) | const`[virtual, inherited]`

Get the shadow camera setup in use for all lights which don't have their own shadow camera setup.

See also:
  ShadowCameraSetup

const VisibleObjectsBoundsInfo& Ogre::SceneManager::getShadowCasterBoundsInfo | ( | const Light * | light | ) | const`[inherited]`

| Returns the shadow caster AAB for a specific light-camera combination.

virtual bool Ogre::SceneManager::getShadowCasterRenderBackFaces | ( |  | ) | const`[virtual, inherited]`

| Gets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces. Definition at line 2412 of file OgreSceneManager.h.

virtual const ColourValue& Ogre::SceneManager::getShadowColour | ( | void |  | ) | const`[virtual, inherited]`

Get the colour used to modulate areas in shadow.

Remarks:
  This is only applicable for shadow techniques which involve darkening the area in shadow, as opposed to masking out the light. This colour provided is used as a modulative value to darken the areas.

virtual Real Ogre::SceneManager::getShadowDirectionalLightExtrusionDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the distance a shadow volume is extruded for a directional light.

virtual Real Ogre::SceneManager::getShadowDirLightTextureOffset | ( | void |  | ) | const`[virtual, inherited]`

| Gets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space. Definition at line 2316 of file OgreSceneManager.h.

virtual Real Ogre::SceneManager::getShadowFarDistance | ( | void |  | ) | const`[virtual, inherited]`

| Gets the maximum distance away from the camera that shadows will be visible. Definition at line 2196 of file OgreSceneManager.h.

virtual size_t Ogre::SceneManager::getShadowIndexBufferSize | ( | void |  | ) | const`[virtual, inherited]`

| Get the size of the shadow index buffer. Definition at line 2226 of file OgreSceneManager.h.

virtual ShadowTechnique Ogre::SceneManager::getShadowTechnique | ( | void |  | ) | const`[virtual, inherited]`

| Gets the current shadow technique. Definition at line 2141 of file OgreSceneManager.h.

virtual const TexturePtr& Ogre::SceneManager::getShadowTexture | ( | size_t | shadowIndex | ) | `[virtual, inherited]`

Get a reference to the shadow texture currently in use at the given index.

Note:
  If you change shadow settings, this reference may no longer be correct, so be sure not to hold the returned reference over texture shadow configuration changes.

ConstShadowTextureConfigIterator Ogre::SceneManager::getShadowTextureConfigIterator | ( |  | ) | const`[inherited]`

| Get an iterator over the current shadow texture settings.

size_t Ogre::SceneManager::getShadowTextureCount | ( | void |  | ) | const`[inherited]`

| Get the number of the textures allocated for texture based shadows. Definition at line 2278 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::getShadowTextureSelfShadow | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether or not texture shadows attempt to self-shadow. Definition at line 2351 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::getShowBoundingBoxes | ( |  | ) | const`[virtual, inherited]`

| Returns if all bounding boxes of scene nodes are to be displayed.

virtual bool Ogre::SceneManager::getShowDebugShadows | ( | void |  | ) | const`[virtual, inherited]`

| Are debug shadows shown? Definition at line 2146 of file OgreSceneManager.h.

virtual const SkyBoxGenParameters& Ogre::SceneManager::getSkyBoxGenParameters | ( | void |  | ) | const`[virtual, inherited]`

| Get the parameters used to generate the current SkyBox, if any. Definition at line 1615 of file OgreSceneManager.h.

virtual SceneNode* Ogre::SceneManager::getSkyBoxNode | ( | void |  | ) | const`[virtual, inherited]`

| Get the skybox node, if enabled. Definition at line 1612 of file OgreSceneManager.h.

virtual const SkyDomeGenParameters& Ogre::SceneManager::getSkyDomeGenParameters | ( | void |  | ) | const`[virtual, inherited]`

| Get the parameters used to generate the current SkyDome, if any. Definition at line 1686 of file OgreSceneManager.h.

virtual SceneNode* Ogre::SceneManager::getSkyDomeNode | ( | void |  | ) | const`[virtual, inherited]`

| Get the sky dome node, if enabled. Definition at line 1683 of file OgreSceneManager.h.

virtual const SkyPlaneGenParameters& Ogre::SceneManager::getSkyPlaneGenParameters | ( | void |  | ) | const`[virtual, inherited]`

| Get the parameters used to construct the SkyPlane, if any *. Definition at line 1560 of file OgreSceneManager.h.

virtual SceneNode* Ogre::SceneManager::getSkyPlaneNode | ( | void |  | ) | const`[virtual, inherited]`

| Get the sky plane node, if enabled. Definition at line 1557 of file OgreSceneManager.h.

virtual SpecialCaseRenderQueueMode Ogre::SceneManager::getSpecialCaseRenderQueueMode | ( | void |  | ) | `[virtual, inherited]`

| Gets the way the special case render queue list is processed.

virtual StaticGeometry* Ogre::SceneManager::getStaticGeometry | ( | const String & | name | ) | const`[virtual, inherited]`

Retrieve a previously created StaticGeometry instance.

Note:
  Throws an exception if the named instance does not exist

virtual ViewPoint Ogre::SceneManager::getSuggestedViewpoint | ( | bool | random = `false` | ) | `[virtual, inherited]`

Asks the SceneManager to provide a suggested viewpoint from which the scene should be viewed.

Remarks:
  Typically this method returns the origin unless a) world geometry has been loaded using SceneManager::setWorldGeometry and b) that world geometry has suggested 'start' points. If there is more than one viewpoint which the scene manager can suggest, it will always suggest the first one unless the random parameter is true.

Parameters:

  | random | If true, and there is more than one possible suggestion, a random one will be used. If false the same one will always be suggested.

Returns:
  On success, true is returned.

  On failiure, false is returned.

const String& Ogre::DefaultSceneManager::getTypeName | ( | void |  | ) | const`[virtual]`

Retrieve the type name of this scene manager.

Remarks:
  This method has to be implemented by subclasses. It should return the type name of this SceneManager which agrees with the type name of the SceneManagerFactory which created it.

Implements Ogre::SceneManager.

virtual uint32 Ogre::SceneManager::getVisibilityMask | ( | void |  | ) | `[virtual, inherited]`

| Gets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible. Definition at line 2621 of file OgreSceneManager.h.

const VisibleObjectsBoundsInfo& Ogre::SceneManager::getVisibleObjectsBoundsInfo | ( | const Camera * | cam | ) | const`[inherited]`

| Returns a visibility boundary box for a specific camera.

virtual uint8 Ogre::SceneManager::getWorldGeometryRenderQueue | ( | void |  | ) | `[virtual, inherited]`

Gets the render queue that the world geometry (if any) this SceneManager renders will be associated with.

Remarks:
  SceneManagers which provide 'world geometry' should place it in a specialised render queue in order to make it possible to enable / disable it easily using the addSpecialCaseRenderQueue method. Even if the SceneManager does not use the render queues to render the world geometry, it should still pick a queue to represent it's manual rendering, and check isRenderQueueToBeProcessed before rendering.

virtual bool Ogre::SceneManager::hasAnimation | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether an animation with the given name exists.

virtual bool Ogre::SceneManager::hasAnimationState | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether an animation state with the given name exists.

virtual bool Ogre::SceneManager::hasBillboardChain | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a billboard chain with the given name exists.

virtual bool Ogre::SceneManager::hasBillboardSet | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a billboardset with the given name exists.

virtual bool Ogre::SceneManager::hasCamera | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a camera with the given name exists.

virtual bool Ogre::SceneManager::hasEntity | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether an entity with the given name exists.

virtual bool Ogre::SceneManager::hasLight | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a light with the given name exists.

virtual bool Ogre::SceneManager::hasManualObject | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a manual object with the given name exists.

virtual bool Ogre::SceneManager::hasMovableObject | ( | const String & | name,
|  | const String & | typeName
| ) | const`[virtual, inherited]`

| Returns whether a movable object instance with the given name exists.

virtual bool Ogre::SceneManager::hasOption | ( | const String & | strKey | ) | const`[virtual, inherited]`

Method for verifying wether the scene manager has an implementation-specific option.

Parameters:

  | strKey | The name of the option to check for.

Returns:
  If the scene manager contains the given option, true is returned.

Remarks:
  If it does not, false is returned.

Definition at line 1404 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::hasParticleSystem | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a particle system with the given name exists.

virtual bool Ogre::SceneManager::hasRibbonTrail | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a ribbon trail with the given name exists.

virtual bool Ogre::SceneManager::hasSceneNode | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a scene node with the given name exists.

virtual bool Ogre::SceneManager::hasStaticGeometry | ( | const String & | name | ) | const`[virtual, inherited]`

| Returns whether a static geometry instance with the given name exists.

virtual void Ogre::SceneManager::initRenderQueue | ( | void |  | ) | `[protected, virtual, inherited]`

Internal method for initialising the render queue.

Remarks:
  Subclasses can use this to install their own RenderQueue implementation.

virtual void Ogre::SceneManager::initShadowVolumeMaterials | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for setting up materials for shadows.

virtual void Ogre::SceneManager::injectMovableObject | ( | MovableObject * | m | ) | `[virtual, inherited]`

Inject a MovableObject instance created externally.

Remarks:
  This method 'injects' a MovableObject instance created externally into the MovableObject instance registry held in the SceneManager. You might want to use this if you have a MovableObject which you don't want to register a factory for; for example a MovableObject which cannot be generally constructed by clients.

Note:
  It is important that the MovableObject has a unique name for the type, and that its getMovableType() method returns a proper type name.

virtual bool Ogre::SceneManager::isRenderQueueToBeProcessed | ( | uint8 | qid | ) | `[virtual, inherited]`

Returns whether or not the named queue will be rendered based on the current 'special case' render queue list and mode.

See also:
  SceneManager::addSpecialCaseRenderQueue

Parameters:

  | qid | The identifier of the queue which should be tested

Returns:
  true if the queue will be rendered, false otherwise

virtual bool Ogre::SceneManager::isShadowTechniqueAdditive | ( | void |  | ) | const`[virtual, inherited]`

| Is there an additive shadowing technique in use? Definition at line 2475 of file OgreSceneManager.h. References Ogre::SHADOWDETAILTYPE_ADDITIVE.

virtual bool Ogre::SceneManager::isShadowTechniqueIntegrated | ( | void |  | ) | const`[virtual, inherited]`

| Is the shadow technique integrated into primary materials? Definition at line 2478 of file OgreSceneManager.h. References Ogre::SHADOWDETAILTYPE_INTEGRATED.

virtual bool Ogre::SceneManager::isShadowTechniqueInUse | ( | void |  | ) | const`[virtual, inherited]`

| Is there any shadowing technique in use? Definition at line 2481 of file OgreSceneManager.h. References Ogre::SHADOWTYPE_NONE.

virtual bool Ogre::SceneManager::isShadowTechniqueModulative | ( | void |  | ) | const`[virtual, inherited]`

| Is there a modulative shadowing technique in use? Definition at line 2472 of file OgreSceneManager.h. References Ogre::SHADOWDETAILTYPE_MODULATIVE.

virtual bool Ogre::SceneManager::isShadowTechniqueStencilBased | ( | void |  | ) | const`[virtual, inherited]`

| Is there a stencil shadow based shadowing technique in use? Definition at line 2466 of file OgreSceneManager.h. References Ogre::SHADOWDETAILTYPE_STENCIL.

virtual bool Ogre::SceneManager::isShadowTechniqueTextureBased | ( | void |  | ) | const`[virtual, inherited]`

| Is there a texture shadow based shadowing technique in use? Definition at line 2469 of file OgreSceneManager.h. References Ogre::SHADOWDETAILTYPE_TEXTURE.

virtual bool Ogre::SceneManager::isSkyBoxEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Return whether a skybox is enabled. Definition at line 1609 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::isSkyDomeEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Return whether a skydome is enabled. Definition at line 1680 of file OgreSceneManager.h.

virtual bool Ogre::SceneManager::isSkyPlaneEnabled | ( | void |  | ) | const`[virtual, inherited]`

| Return whether a key plane is enabled. Definition at line 1554 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::manualRender | ( | RenderOperation * | rend,
|  | Pass * | pass,
|  | Viewport * | vp,
|  | const Matrix4 & | worldMatrix,
|  | const Matrix4 & | viewMatrix,
|  | const Matrix4 & | projMatrix,
|  | bool | doBeginEndFrame = `false`
| ) | `[virtual, inherited]`

Manual rendering method, for advanced users only.

Remarks:
  This method allows you to send rendering commands through the pipeline on demand, bypassing OGRE's normal world processing. You should only use this if you really know what you're doing; OGRE does lots of things for you that you really should let it do. However, there are times where it may be useful to have this manual interface, for example overlaying something on top of the scene rendered by OGRE.

  Because this is an instant rendering method, timing is important. The best time to call it is from a RenderTargetListener event handler.

  Don't call this method a lot, it's designed for rare (1 or 2 times per frame) use. Calling it regularly per frame will cause frame rate drops!

Parameters:

  | rend | A RenderOperation object describing the rendering op
  | pass | The Pass to use for this render
  | vp | Pointer to the viewport to render to
  | worldMatrix | The transform to apply from object to world space
  | viewMatrix | The transform to apply from world to view space
  | projMatrix | The transform to apply from view to screen space
  | doBeginEndFrame | If true, beginFrame() and endFrame() are called, otherwise not. You should leave this as false if you are calling this within the main render loop.

virtual void Ogre::SceneManager::prepareRenderQueue | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for preparing the render queue for use with each render.

virtual void Ogre::SceneManager::prepareShadowTextures | ( | Camera * | cam,
|  | Viewport * | vp
| ) | `[protected, virtual, inherited]`

| Internal method for preparing shadow textures ready for use in a regular render.

virtual void Ogre::SceneManager::removeRenderQueueListener | ( | RenderQueueListener * | delListener | ) | `[virtual, inherited]`

| Removes a listener previously added with addRenderQueueListener.

virtual void Ogre::SceneManager::removeShadowListener | ( | ShadowListener * | s | ) | `[virtual, inherited]`

| Remove a shadow listener.

virtual void Ogre::SceneManager::removeSpecialCaseRenderQueue | ( | uint8 | qid | ) | `[virtual, inherited]`

Removes an item to the 'special case' render queue list.

See also:
  SceneManager::addSpecialCaseRenderQueue

Parameters:

  | qid | The identifier of the queue which should be removed from the special case list. Nothing happens if the queue is not in the list.

virtual void Ogre::SceneManager::renderAdditiveStencilShadowedQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group with the added complexity of additive stencil shadows.

virtual void Ogre::SceneManager::renderAdditiveTextureShadowedQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group with additive texture shadows.

virtual void Ogre::SceneManager::renderBasicQueueGroupObjects | ( | RenderQueueGroup * | pGroup,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group in the ordinary way.

virtual void Ogre::SceneManager::renderModulativeStencilShadowedQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group with the added complexity of modulative stencil shadows.

virtual void Ogre::SceneManager::renderModulativeTextureShadowedQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group with the added complexity of modulative texture shadows.

virtual void Ogre::SceneManager::renderObjects | ( | const QueuedRenderableCollection & | objs,
|  | QueuedRenderableCollection::OrganisationMode | om,
|  | bool | doLightIteration,
|  | const LightList * | manualLightList = `0`
| ) | `[protected, virtual, inherited]`

| Render a set of objects, see renderSingleObject for param definitions.

void Ogre::SceneManager::renderShadowVolumeObjects | ( | ShadowCaster::ShadowRenderableListIterator | iShadowRenderables,
|  | Pass * | pass,
|  | const LightList * | manualLightList,
|  | unsigned long | flags,
|  | bool | secondpass,
|  | bool | zfail,
|  | bool | twosided
| ) | `[protected, inherited]`

| Render a set of shadow renderables.

virtual void Ogre::SceneManager::renderShadowVolumesToStencil | ( | const Light * | light,
|  | const Camera * | cam
| ) | `[protected, virtual, inherited]`

Internal method for rendering all the objects for a given light into the stencil buffer.

Parameters:

  | light | The light source
  | cam | The camera being viewed from

virtual void Ogre::SceneManager::renderSingleObject | ( | const Renderable * | rend,
|  | const Pass * | pass,
|  | bool | doLightIteration,
|  | const LightList * | manualLightList = `0`
| ) | `[protected, virtual, inherited]`

Internal utility method for rendering a single object.

Remarks:
  Assumes that the pass has already been set up.

Parameters:

  | rend | The renderable to issue to the pipeline
  | pass | The pass which is being used
  | doLightIteration | If true, this method will issue the renderable to the pipeline possibly multiple times, if the pass indicates it should be done once per light
  | manualLightList | Only applicable if doLightIteration is false, this method allows you to pass in a previously determined set of lights which will be used for a single render of this object.

virtual void Ogre::SceneManager::renderTextureShadowCasterQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group rendering only shadow casters.

virtual void Ogre::SceneManager::renderTextureShadowReceiverQueueGroupObjects | ( | RenderQueueGroup * | group,
|  | QueuedRenderableCollection::OrganisationMode | om
| ) | `[protected, virtual, inherited]`

| Render a group rendering only shadow receivers.

virtual void Ogre::SceneManager::renderTransparentShadowCasterObjects | ( | const QueuedRenderableCollection & | objs,
|  | QueuedRenderableCollection::OrganisationMode | om,
|  | bool | doLightIteration,
|  | const LightList * | manualLightList = `0`
| ) | `[protected, virtual, inherited]`

Render those objects in the transparent pass list which have shadow casting forced on.

Remarks:
  This function is intended to be used to render the shadows of transparent objects which have transparency_casts_shadows set to 'on' in their material

virtual void Ogre::SceneManager::renderVisibleObjectsCustomSequence | ( | RenderQueueInvocationSequence * | s | ) | `[protected, virtual, inherited]`

| Internal method for rendering all objects using a custom queue sequence.

virtual void Ogre::SceneManager::renderVisibleObjectsDefaultSequence | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for rendering all objects using the default queue sequence.

virtual void Ogre::SceneManager::resetViewProjMode | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method used by _renderSingleObject to deal with renderables which override the camera's own view / projection matrices.

void Ogre::SceneManager::setAmbientLight | ( | const ColourValue & | colour | ) | `[inherited]`

Sets the ambient light level to be used for the scene.

Remarks:
  This sets the colour and intensity of the ambient light in the scene, i.e. the light which is 'sourceless' and illuminates all objects equally. The colour of an object is affected by a combination of the light in the scene, and the amount of light that object reflects (in this case based on the Material::ambient property).

  By default the ambient light in the scene is ColourValue::Black, i.e. no ambient light. This means that any objects rendered with a Material which has lighting enabled (see Material::setLightingEnabled) will not be visible unless you have some dynamic lights in your scene.

virtual void Ogre::SceneManager::setDisplaySceneNodes | ( | bool | display | ) | `[virtual, inherited]`

Tells the SceneManager whether it should render the SceneNodes which make up the scene as well as the objects in the scene.

Remarks:
  This method is mainly for debugging purposes. If you set this to 'true', each node will be rendered as a set of 3 axes to allow you to easily see the orientation of the nodes.

virtual void Ogre::SceneManager::setFindVisibleObjects | ( | bool | find | ) | `[virtual, inherited]`

Sets whether the SceneManager should search for visible objects, or whether they are being manually handled.

Remarks:
  This is an advanced function, you should not use this unless you know what you are doing.

Definition at line 2634 of file OgreSceneManager.h.

void Ogre::SceneManager::setFog | ( | FogMode | mode = `FOG_NONE`,
|  | const ColourValue & | colour = `ColourValue::White`,
|  | Real | expDensity = `0.001`,
|  | Real | linearStart = `0.0`,
|  | Real | linearEnd = `1.0`
| ) | `[inherited]`

Sets the fogging mode applied to the scene.

Remarks:
  This method sets up the scene-wide fogging effect. These settings apply to all geometry rendered, UNLESS the material with which it is rendered has it's own fog settings (see Material::setFog).

Parameters:

  | mode | Set up the mode of fog as described in the FogMode enum, or set to FOG_NONE to turn off.
  | colour | The colour of the fog. Either set this to the same as your viewport background colour, or to blend in with a skydome or skybox.
  | expDensity | The density of the fog in FOG_EXP or FOG_EXP2 mode, as a value between 0 and 1. The default is 0.001.
  | linearStart | Distance in world units at which linear fog starts to encroach. Only applicable if mode is FOG_LINEAR.
  | linearEnd | Distance in world units at which linear fog becomes completely opaque. Only applicable if mode is FOG_LINEAR.

virtual bool Ogre::SceneManager::setOption | ( | const String & | strKey,
|  | const void * | pValue
| ) | `[virtual, inherited]`

Method for setting a specific option of the Scene Manager.

These options are usually specific for a certain implemntation of the Scene Manager class, and may (and probably will) not exist across different implementations.

Parameters:

  | strKey | The name of the option to set
  | pValue | A pointer to the value - the size should be calculated by the scene manager based on the key

Returns:
  On success, true is returned.

  On failiure, false is returned.

Definition at line 1378 of file OgreSceneManager.h.

void Ogre::SceneManager::setQueuedRenderableVisitor | ( | SceneMgrQueuedRenderableVisitor * | visitor | ) | `[inherited]`

Advanced method for supplying an alternative visitor, used for parsing the render queues and sending the results to the renderer.

Remarks:
  You can use this method to insert your own implementation of the QueuedRenderableVisitor interface, which receives calls as the queued renderables are parsed in a given order (determined by RenderQueueInvocationSequence) and are sent to the renderer. If you provide your own implementation of this visitor, you are responsible for either calling the rendersystem, or passing the calls on to the base class implementation.

Note:
  Ownership is not taken of this pointer, you are still required to delete it yourself once you're finished.

Parameters:

  | visitor | Your implementation of SceneMgrQueuedRenderableVisitor. If you pass 0, the default implementation will be used.

virtual void Ogre::SceneManager::setShadowCameraSetup | ( | const ShadowCameraSetupPtr & | shadowSetup | ) | `[virtual, inherited]`

Set the shadow camera setup to use for all lights which don't have their own shadow camera setup.

See also:
  ShadowCameraSetup

virtual void Ogre::SceneManager::setShadowCasterRenderBackFaces | ( | bool | bf | ) | `[virtual, inherited]`

Sets whether or not shadow casters should be rendered into shadow textures using their back faces rather than their front faces.

Remarks:
  Rendering back faces rather than front faces into a shadow texture can help minimise depth comparison issues, if you're using depth shadowmapping. You will probably still need some biasing but you won't need as much. For solid objects the result is the same anyway, if you have objects with holes you may want to turn this option off. The default is to enable this option.

Definition at line 2407 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setShadowColour | ( | const ColourValue & | colour | ) | `[virtual, inherited]`

Set the colour used to modulate areas in shadow.

Remarks:
  This is only applicable for shadow techniques which involve darkening the area in shadow, as opposed to masking out the light. This colour provided is used as a modulative value to darken the areas.

virtual void Ogre::SceneManager::setShadowDirectionalLightExtrusionDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance a shadow volume is extruded for a directional light.

Remarks:
  Although directional lights are essentially infinite, there are many reasons to limit the shadow extrusion distance to a finite number, not least of which is compatibility with older cards (which do not support infinite positions), and shadow caster elimination.

  The default value is 10,000 world units. This does not apply to point lights or spotlights, since they extrude up to their attenuation range.

virtual void Ogre::SceneManager::setShadowDirLightTextureOffset | ( | Real | offset | ) | `[virtual, inherited]`

Sets the proportional distance which a texture shadow which is generated from a directional light will be offset into the camera view to make best use of texture space.

Remarks:
  When generating a shadow texture from a directional light, an approximation is used since it is not possible to render the entire scene to one texture. The texture is projected onto an area centred on the camera, and is the shadow far distance * 2 in length (it is square). This wastes a lot of texture space outside the frustum though, so this offset allows you to move the texture in front of the camera more. However, be aware that this can cause a little shadow 'jittering' during rotation, and that if you move it too far then you'll start to get artefacts close to the camera. The value is represented as a proportion of the shadow far distance, and the default is 0.6.

Definition at line 2312 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setShadowFarDistance | ( | Real | distance | ) | `[virtual, inherited]`

Sets the maximum distance away from the camera that shadows will be visible.

Remarks:
  Shadow techniques can be expensive, therefore it is a good idea to limit them to being rendered close to the camera if possible, and to skip the expense of rendering shadows for distance objects. This method allows you to set the distance at which shadows will no longer be rendered.

Note:
  Each shadow technique can interpret this subtely differently. For example, one technique may use this to eliminate casters, another might use it to attenuate the shadows themselves. You should tweak this value to suit your chosen shadow technique and scene setup.

virtual void Ogre::SceneManager::setShadowIndexBufferSize | ( | size_t | size | ) | `[virtual, inherited]`

Sets the maximum size of the index buffer used to render shadow primitives.

Remarks:
  This method allows you to tweak the size of the index buffer used to render shadow primitives (including stencil shadow volumes). The default size is 51,200 entries, which is 100k of GPU memory, or enough to render approximately 17,000 triangles. You can reduce this as long as you do not have any models / world geometry chunks which could require more than the amount you set.

  The maximum number of triangles required to render a single shadow volume (including light and dark caps when needed) will be 3x the number of edges on the light silhouette, plus the number of light-facing triangles. On average, half the triangles will be facing toward the light, but the number of triangles in the silhouette entirely depends on the mesh - angular meshes will have a higher silhouette tris/mesh tris ratio than a smooth mesh. You can estimate the requirements for your particular mesh by rendering it alone in a scene with shadows enabled and a single light - rotate it or the light and make a note of how high the triangle count goes (remembering to subtract the mesh triangle count)

Parameters:

  | size | The number of indexes; divide this by 3 to determine the number of triangles.

virtual void Ogre::SceneManager::setShadowTechnique | ( | ShadowTechnique | technique | ) | `[virtual, inherited]`

Sets the general shadow technique to be used in this scene.

Remarks:
  There are multiple ways to generate shadows in a scene, and each has strengths and weaknesses.
  - Stencil-based approaches can be used to draw very long, extreme shadows without loss of precision and the 'additive' version can correctly show the shadowing of complex effects like bump mapping because they physically exclude the light from those areas. However, the edges are very sharp and stencils cannot handle transparency, and they involve a fair amount of CPU work in order to calculate the shadow volumes, especially when animated objects are involved.
  - Texture-based approaches are good for handling transparency (they can, for example, correctly shadow a mesh which uses alpha to represent holes), and they require little CPU overhead, and can happily shadow geometry which is deformed by a vertex program, unlike stencil shadows. However, they have a fixed precision which can introduce 'jaggies' at long range and have fillrate issues of their own.

  We support 2 kinds of stencil shadows, and 2 kinds of texture-based shadows, and one simple decal approach. The 2 stencil approaches differ in the amount of multipass work that is required - the modulative approach simply 'darkens' areas in shadow after the main render, which is the least expensive, whilst the additive approach has to perform a render per light and adds the cumulative effect, whcih is more expensive but more accurate. The texture based shadows both work in roughly the same way, the only difference is that the shadowmap approach is slightly more accurate, but requires a more recent graphics card.

  Note that because mixing many shadow techniques can cause problems, only one technique is supported at once. Also, you should call this method at the start of the scene setup.

Parameters:

  | technique | The shadowing technique to use for the scene.

virtual void Ogre::SceneManager::setShadowTextureCasterMaterial | ( | const String & | name | ) | `[virtual, inherited]`

Sets the default material to use for rendering shadow casters.

Remarks:
  By default shadow casters are rendered into the shadow texture using an automatically generated fixed-function pass. This allows basic projective texture shadows, but it's possible to use more advanced shadow techniques by overriding the caster and receiver materials, for example providing vertex and fragment programs to implement shadow maps.

  You can rely on the ambient light in the scene being set to the requested texture shadow colour, if that's useful.

Note:
  Individual objects may also override the vertex program in your default material if their materials include shadow_caster_vertex_program_ref shadow_receiver_vertex_program_ref entries, so if you use both make sure they are compatible.

  Only a single pass is allowed in your material, although multiple techniques may be used for hardware fallback.

virtual void Ogre::SceneManager::setShadowTextureConfig | ( | size_t | shadowIndex,
|  | const ShadowTextureConfig & | config
| ) | `[virtual, inherited]`

Set the detailed configuration for a shadow texture.

Parameters:

  | shadowIndex | The index of the texture to configure, must be < the number of shadow textures setting
  | config | Configuration structure

virtual void Ogre::SceneManager::setShadowTextureConfig | ( | size_t | shadowIndex,
|  | unsigned short | width,
|  | unsigned short | height,
|  | PixelFormat | format
| ) | `[virtual, inherited]`

Set the detailed configuration for a shadow texture.

Parameters:

  | shadowIndex | The index of the texture to configure, must be < the number of shadow textures setting
  | width,height | The dimensions of the texture
  | format | The pixel format of the texture

virtual void Ogre::SceneManager::setShadowTextureCount | ( | size_t | count | ) | `[virtual, inherited]`

Set the number of textures allocated for texture-based shadows.

Remarks:
  The default number of textures assigned to deal with texture based shadows is 1; however this means you can only have one light casting shadows at the same time. You can increase this number in order to make this more flexible, but be aware of the texture memory it will use.

virtual void Ogre::SceneManager::setShadowTextureFadeEnd | ( | Real | fadeEnd | ) | `[virtual, inherited]`

Sets the proportional distance at which texture shadows finish to fading out.

Remarks:
  To hide the edges where texture shadows end (in directional lights) Ogre will fade out the shadow in the distance. This value is a proportional distance of the entire shadow visibility distance at which the shadow is completely invisible. The default is 0.9.

Definition at line 2333 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setShadowTextureFadeStart | ( | Real | fadeStart | ) | `[virtual, inherited]`

Sets the proportional distance at which texture shadows begin to fade out.

Remarks:
  To hide the edges where texture shadows end (in directional lights) Ogre will fade out the shadow in the distance. This value is a proportional distance of the entire shadow visibility distance at which the shadow begins to fade out. The default is 0.7

Definition at line 2324 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setShadowTexturePixelFormat | ( | PixelFormat | fmt | ) | `[virtual, inherited]`

Set the pixel format of the textures used for texture-based shadows.

Remarks:
  By default, a colour texture is used (PF_X8R8G8B8) for texture shadows, but if you want to use more advanced texture shadow types you can alter this. If you do, you will have to also call setShadowTextureCasterMaterial and setShadowTextureReceiverMaterial to provide shader-based materials to use these customised shadow texture formats.

Note:
  This is the simple form, see setShadowTextureConfig for the more complex form.

virtual void Ogre::SceneManager::setShadowTextureReceiverMaterial | ( | const String & | name | ) | `[virtual, inherited]`

Sets the default material to use for rendering shadow receivers.

Remarks:
  By default shadow receivers are rendered as a post-pass using basic modulation. This allows basic projective texture shadows, but it's possible to use more advanced shadow techniques by overriding the caster and receiver materials, for example providing vertex and fragment programs to implement shadow maps.

  You can rely on texture unit 0 containing the shadow texture, and for the unit to be set to use projective texturing from the light (only useful if you're using fixed-function, which is unlikely; otherwise you should rely on the texture_viewproj_matrix auto binding)

Note:
  Individual objects may also override the vertex program in your default material if their materials include shadow_caster_vertex_program_ref shadow_receiver_vertex_program_ref entries, so if you use both make sure they are compatible.

  Only a single pass is allowed in your material, although multiple techniques may be used for hardware fallback.

virtual void Ogre::SceneManager::setShadowTextureSelfShadow | ( | bool | selfShadow | ) | `[virtual, inherited]`

Sets whether or not texture shadows should attempt to self-shadow.

Remarks:
  The default implementation of texture shadows uses a fixed-function colour texture projection approach for maximum compatibility, and as such cannot support self-shadowing. However, if you decide to implement a more complex shadowing technique using the setShadowTextureCasterMaterial and setShadowTextureReceiverMaterial there is a possibility you may be able to support self-shadowing (e.g by implementing a shader-based shadow map). In this case you might want to enable this option.

Parameters:

  | selfShadow | Whether to attempt self-shadowing with texture shadows

virtual void Ogre::SceneManager::setShadowTextureSettings | ( | unsigned short | size,
|  | unsigned short | count,
|  | PixelFormat | fmt = `PF_X8R8G8B8`
| ) | `[virtual, inherited]`

Sets the size and count of textures used in texture-based shadows.

Remarks:

See also:
  setShadowTextureSize and setShadowTextureCount for details, this method just allows you to change both at once, which can save on reallocation if the textures have already been created.

Note:
  This is the simple form, see setShadowTextureConfig for the more complex form.

virtual void Ogre::SceneManager::setShadowTextureSize | ( | unsigned short | size | ) | `[virtual, inherited]`

Set the size of the texture used for all texture-based shadows.

Remarks:
  The larger the shadow texture, the better the detail on texture based shadows, but obviously this takes more memory. The default size is 512. Sizes must be a power of 2.

Note:
  This is the simple form, see setShadowTextureConfig for the more complex form.

virtual void Ogre::SceneManager::setShadowUseInfiniteFarPlane | ( | bool | enable | ) | `[virtual, inherited]`

Sets whether we should use an inifinite camera far plane when rendering stencil shadows.

Remarks:
  Stencil shadow coherency is very reliant on the shadow volume not being clipped by the far plane. If this clipping happens, you get a kind of 'negative' shadow effect. The best way to achieve coherency is to move the far plane of the camera out to infinity, thus preventing the far plane from clipping the shadow volumes. When combined with vertex program extrusion of the volume to infinity, which Ogre does when available, this results in very robust shadow volumes. For this reason, when you enable stencil shadows, Ogre automatically changes your camera settings to project to infinity if the card supports it. You can disable this behaviour if you like by calling this method; although you can never enable infinite projection if the card does not support it.

  If you disable infinite projection, or it is not available, you need to be far more careful with your light attenuation / directional light extrusion distances to avoid clipping artefacts at the far plane.

Note:
  Recent cards will generally support infinite far plane projection. However, we have found some cases where they do not, especially on Direct3D. There is no standard capability we can check to validate this, so we use some heuristics based on experience:
  - OpenGL always seems to support it no matter what the card
  - Direct3D on non-vertex program capable systems (including vertex program capable cards on Direct3D7) does not support it
  - Direct3D on GeForce3 and GeForce4 Ti does not seem to support infinite projection
  Therefore in the RenderSystem implementation, we may veto the use of an infinite far plane based on these heuristics.

Definition at line 2462 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setShadowVolumeStencilState | ( | bool | secondpass,
|  | bool | zfail,
|  | bool | twosided
| ) | `[protected, virtual, inherited]`

Internal utility method for setting stencil state for rendering shadow volumes.

Parameters:

  | secondpass | Is this the second pass?
  | zfail | Should we be using the zfail method?
  | twosided | Should we use a 2-sided stencil?

virtual void Ogre::SceneManager::setShowDebugShadows | ( | bool | debug | ) | `[virtual, inherited]`

| Enables / disables the rendering of debug information for shadows. Definition at line 2144 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setSkyBox | ( | bool | enable,
|  | const String & | materialName,
|  | Real | distance = `5000`,
|  | bool | drawFirst = `true`,
|  | const Quaternion & | orientation = `Quaternion::IDENTITY`,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[virtual, inherited]`

Enables / disables a 'sky box' i.e.

a 6-sided box at constant distance from the camera representing the sky.

Remarks:
  You could create a sky box yourself using the standard mesh and entity methods, but this creates a plane which the camera can never get closer or further away from - it moves with the camera. (NB you could create this effect by creating a world box which was attached to the same SceneNode as the Camera too, but this would only apply to a single camera whereas this skybox applies to any camera using this scene manager).

  The material you use for the skybox can either contain layers which are single textures, or they can be cubic textures, i.e. made up of 6 images, one for each plane of the cube. See the TextureUnitState class for more information.

Parameters:

  | enable | True to enable the skybox, false to disable it
  | materialName | The name of the material the box will use
  | distance | Distance in world coorinates from the camera to each plane of the box. The default is normally OK.
  | drawFirst | If true, the box is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the distance value is large enough that no objects will 'poke through' the sky box when it is rendered.
  | orientation | Optional parameter to specify the orientation of the box. By default the 'top' of the box is deemed to be in the +y direction, and the 'front' at the -z direction. You can use this parameter to rotate the sky if you want.
  | groupName | The name of the resource group to which to assign the plane mesh.

virtual void Ogre::SceneManager::setSkyDome | ( | bool | enable,
|  | const String & | materialName,
|  | Real | curvature = `10`,
|  | Real | tiling = `8`,
|  | Real | distance = `4000`,
|  | bool | drawFirst = `true`,
|  | const Quaternion & | orientation = `Quaternion::IDENTITY`,
|  | int | xsegments = `16`,
|  | int | ysegments = `16`,
|  | int | ysegments_keep = `-1`,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[virtual, inherited]`

Enables / disables a 'sky dome' i.e.

an illusion of a curved sky.

Remarks:
  A sky dome is actually formed by 5 sides of a cube, but with texture coordinates generated such that the surface appears curved like a dome. Sky domes are appropriate where you need a realistic looking sky where the scene is not going to be 'fogged', and there is always a 'floor' of some sort to prevent the viewer looking below the horizon (the distortion effect below the horizon can be pretty horrible, and there is never anyhting directly below the viewer). If you need a complete wrap-around background, use the setSkyBox method instead. You can actually combine a sky box and a sky dome if you want, to give a positional backdrop with an overlayed curved cloud layer.

  Sky domes work well with 2D repeating textures like clouds. You can change the apparant 'curvature' of the sky depending on how your scene is viewed - lower curvatures are better for 'open' scenes like landscapes, whilst higher curvatures are better for say FPS levels where you don't see a lot of the sky at once and the exaggerated curve looks good.

Parameters:

  | enable | True to enable the skydome, false to disable it
  | materialName | The name of the material the dome will use
  | curvature | The curvature of the dome. Good values are between 2 and 65. Higher values are more curved leading to a smoother effect, lower values are less curved meaning more distortion at the horizons but a better distance effect.
  | tiling | How many times to tile the texture(s) across the dome.
  | distance | Distance in world coorinates from the camera to each plane of the box the dome is rendered on. The default is normally OK.
  | drawFirst | If true, the dome is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the distance value is large enough that no objects will 'poke through' the sky when it is rendered.
  | orientation | Optional parameter to specify the orientation of the dome. By default the 'top' of the dome is deemed to be in the +y direction, and the 'front' at the -z direction. You can use this parameter to rotate the sky if you want.
  | groupName | The name of the resource group to which to assign the plane mesh.

virtual void Ogre::SceneManager::setSkyPlane | ( | bool | enable,
|  | const Plane & | plane,
|  | const String & | materialName,
|  | Real | scale = `1000`,
|  | Real | tiling = `10`,
|  | bool | drawFirst = `true`,
|  | Real | bow = `0`,
|  | int | xsegments = `1`,
|  | int | ysegments = `1`,
|  | const String & | groupName = `ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME`
| ) | `[virtual, inherited]`

Enables / disables a 'sky plane' i.e.

a plane at constant distance from the camera representing the sky.

Remarks:
  You can create sky planes yourself using the standard mesh and entity methods, but this creates a plane which the camera can never get closer or further away from - it moves with the camera. (NB you could create this effect by creating a world plane which was attached to the same SceneNode as the Camera too, but this would only apply to a single camera whereas this plane applies to any camera using this scene manager).

Note:
  To apply scaling, scrolls etc to the sky texture(s) you should use the TextureUnitState class methods.

Parameters:

  | enable | True to enable the plane, false to disable it
  | plane | Details of the plane, i.e. it's normal and it's distance from the camera.
  | materialName | The name of the material the plane will use
  | scale | The scaling applied to the sky plane - higher values mean a bigger sky plane - you may want to tweak this depending on the size of plane.d and the other characteristics of your scene
  | tiling | How many times to tile the texture across the sky. Applies to all texture layers. If you need finer control use the TextureUnitState texture coordinate transformation methods.
  | drawFirst | If true, the plane is drawn before all other geometry in the scene, without updating the depth buffer. This is the safest rendering method since all other objects will always appear in front of the sky. However this is not the most efficient way if most of the sky is often occluded by other objects. If this is the case, you can set this parameter to false meaning it draws after all other geometry which can be an optimisation - however you must ensure that the plane.d value is large enough that no objects will 'poke through' the sky plane when it is rendered.
  | bow | If zero, the plane will be completely flat (like previous versions. If above zero, the plane will be curved, allowing the sky to appear below camera level. Curved sky planes are simular to skydomes, but are more compatable with fog.
  | xsegments,ysegments | Determines the number of segments the plane will have to it. This is most important when you are bowing the plane, but may also be useful if you need tesselation on the plane to perform per-vertex effects.
  | groupName | The name of the resource group to which to assign the plane mesh.

virtual void Ogre::SceneManager::setSpecialCaseRenderQueueMode | ( | SpecialCaseRenderQueueMode | mode | ) | `[virtual, inherited]`

Sets the way the special case render queue list is processed.

See also:
  SceneManager::addSpecialCaseRenderQueue

Parameters:

  | mode | The mode of processing

virtual void Ogre::SceneManager::setViewport | ( | Viewport * | vp | ) | `[protected, virtual, inherited]`

| Internal method for setting the destination viewport for the next render.

virtual void Ogre::SceneManager::setVisibilityMask | ( | uint32 | vmask | ) | `[virtual, inherited]`

Sets a mask which is bitwise 'and'ed with objects own visibility masks to determine if the object is visible.

Remarks:
  Note that this is combined with any per-viewport visibility mask through an 'and' operation.

See also:
  Viewport::setVisibilityMask

Definition at line 2616 of file OgreSceneManager.h.

virtual void Ogre::SceneManager::setWorldGeometry | ( | DataStreamPtr & | stream,
|  | const String & | typeName = `StringUtil::BLANK`
| ) | `[virtual, inherited]`

Sets the source of the 'world' geometry, i.e.

the large, mainly static geometry making up the world e.g. rooms, landscape etc.

Remarks:
  Depending on the type of SceneManager (subclasses will be specialised for particular world geometry types) you have requested via the Root or SceneManagerEnumerator classes, you can pass a stream to this method and it will attempt to load the world-level geometry for use. If the manager can only handle one input format the typeName parameter is not required. The stream passed will be read (and it's state updated).

Parameters:

  | stream | Data stream containing data to load
  | typeName | String identifying the type of world geometry contained in the stream - not required if this manager only supports one type of world geometry.

virtual void Ogre::SceneManager::setWorldGeometry | ( | const String & | filename | ) | `[virtual, inherited]`

Sets the source of the 'world' geometry, i.e.

the large, mainly static geometry making up the world e.g. rooms, landscape etc.

Remarks:
  Depending on the type of SceneManager (subclasses will be specialised for particular world geometry types) you have requested via the Root or SceneManagerEnumerator classes, you can pass a filename to this method and it will attempt to load the world-level geometry for use. If you try to load an inappropriate type of world data an exception will be thrown. The default SceneManager cannot handle any sort of world geometry and so will always throw an exception. However subclasses like BspSceneManager can load particular types of world geometry e.g. "q3dm1.bsp".

virtual void Ogre::SceneManager::setWorldGeometryRenderQueue | ( | uint8 | qid | ) | `[virtual, inherited]`

Sets the render queue that the world geometry (if any) this SceneManager renders will be associated with.

Remarks:
  SceneManagers which provide 'world geometry' should place it in a specialised render queue in order to make it possible to enable / disable it easily using the addSpecialCaseRenderQueue method. Even if the SceneManager does not use the render queues to render the world geometry, it should still pick a queue to represent it's manual rendering, and check isRenderQueueToBeProcessed before rendering.

Note:
  Setting this may not affect the actual ordering of rendering the world geometry, if the world geometry is being rendered manually by the SceneManager. If the SceneManager feeds world geometry into the queues, however, the ordering will be affected.

virtual void Ogre::SceneManager::showBoundingBoxes | ( | bool | bShow | ) | `[virtual, inherited]`

| Allows all bounding boxes of scene nodes to be displayed.

virtual void Ogre::SceneManager::updateRenderQueueGroupSplitOptions | ( | RenderQueueGroup * | group,
|  | bool | suppressShadows,
|  | bool | suppressRenderState
| ) | `[protected, virtual, inherited]`

| Update the state of the render queue group splitting based on a shadow option change.

virtual void Ogre::SceneManager::updateRenderQueueSplitOptions | ( | void |  | ) | `[protected, virtual, inherited]`

| Update the state of the global render queue splitting based on a shadow option change.

virtual void Ogre::SceneManager::useRenderableViewProjMode | ( | const Renderable * | pRend | ) | `[protected, virtual, inherited]`

| Internal method used by _renderSingleObject to deal with renderables which override the camera's own view / projection materices.

virtual bool Ogre::SceneManager::validatePassForRendering | ( | const Pass * | pass | ) | `[protected, virtual, inherited]`

Internal method to validate whether a Pass should be allowed to render.

Remarks:
  Called just before a pass is about to be used for rendering a group to allow the SceneManager to omit it if required. A return value of false skips this pass.

virtual bool Ogre::SceneManager::validateRenderableForRendering | ( | const Pass * | pass,
|  | const Renderable * | rend
| ) | `[protected, virtual, inherited]`

Internal method to validate whether a Renderable should be allowed to render.

Remarks:
  Called just before a pass is about to be used for rendering a Renderable to allow the SceneManager to omit it if required. A return value of false skips it.

## Friends And Related Function Documentation

friend class SceneMgrQueuedRenderableVisitor`[friend, inherited]`

| Allow visitor helper to access protected methods. Definition at line 799 of file OgreSceneManager.h.

## Member Data Documentation

uint32 Ogre::SceneManager::ENTITY_TYPE_MASK`[static, inherited]`

| Query type mask which will be used for entities SceneQuery. Definition at line 224 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::FX_TYPE_MASK`[static, inherited]`

| Query type mask which will be used for effects like billboardsets / particle systems SceneQuery. Definition at line 226 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::LIGHT_TYPE_MASK`[static, inherited]`

| Query type mask which will be used for lights SceneQuery. Definition at line 230 of file OgreSceneManager.h.

SceneMgrQueuedRenderableVisitor* Ogre::SceneManager::mActiveQueuedRenderableVisitor`[protected, inherited]`

| The active renderable visitor class - subclasses could override this. Definition at line 801 of file OgreSceneManager.h.

ColourValue Ogre::SceneManager::mAmbientLight`[protected, inherited]`

| Current ambient light, cached for RenderSystem. Definition at line 300 of file OgreSceneManager.h.

AnimationList Ogre::SceneManager::mAnimationsList`[protected, inherited]`

| Definition at line 523 of file OgreSceneManager.h.

AnimationStateSet Ogre::SceneManager::mAnimationStates`[protected, inherited]`

| Definition at line 525 of file OgreSceneManager.h.

AutoParamDataSource Ogre::SceneManager::mAutoParamDataSource`[protected, inherited]`

| Utility class for calculating automatic parameters for gpu programs. Definition at line 582 of file OgreSceneManager.h.

AutoTrackingSceneNodes Ogre::SceneManager::mAutoTrackingSceneNodes`[protected, inherited]`

| Definition at line 336 of file OgreSceneManager.h.

LightInfoList Ogre::SceneManager::mCachedLightInfos`[protected, inherited]`

| Definition at line 420 of file OgreSceneManager.h.

Camera* Ogre::SceneManager::mCameraInProgress`[protected, inherited]`

| Camera in progress. Definition at line 327 of file OgreSceneManager.h.

CameraList Ogre::SceneManager::mCameras`[protected, inherited]`

| Central list of cameras - for easy memory management and lookup. Definition at line 309 of file OgreSceneManager.h.

CamVisibleObjectsMap Ogre::SceneManager::mCamVisibleObjectsMap`[protected, inherited]`

| Definition at line 391 of file OgreSceneManager.h.

Texture* Ogre::SceneManager::mCurrentShadowTexture`[protected, inherited]`

| Definition at line 602 of file OgreSceneManager.h.

Viewport* Ogre::SceneManager::mCurrentViewport`[protected, inherited]`

| Current Viewport. Definition at line 329 of file OgreSceneManager.h.

bool Ogre::SceneManager::mDebugShadows`[protected, inherited]`

| Definition at line 585 of file OgreSceneManager.h.

SceneMgrQueuedRenderableVisitor Ogre::SceneManager::mDefaultQueuedRenderableVisitor`[protected, inherited]`

| Storage for default renderable visitor. Definition at line 803 of file OgreSceneManager.h.

ShadowCameraSetupPtr Ogre::SceneManager::mDefaultShadowCameraSetup`[protected, inherited]`

| default shadow camera setup Definition at line 607 of file OgreSceneManager.h.

RenderSystem* Ogre::SceneManager::mDestRenderSystem`[protected, inherited]`

| The rendering system to send the scene to. Definition at line 303 of file OgreSceneManager.h.

bool Ogre::SceneManager::mDisplayNodes`[protected, inherited]`

| Definition at line 519 of file OgreSceneManager.h.

bool Ogre::SceneManager::mFindVisibleObjects`[protected, inherited]`

| Definition at line 676 of file OgreSceneManager.h.

GpuProgramParametersSharedPtr Ogre::SceneManager::mFiniteExtrusionParams`[protected, inherited]`

| Definition at line 685 of file OgreSceneManager.h.

ColourValue Ogre::SceneManager::mFogColour`[protected, inherited]`

| Definition at line 366 of file OgreSceneManager.h.

Real Ogre::SceneManager::mFogDensity`[protected, inherited]`

| Definition at line 369 of file OgreSceneManager.h.

Real Ogre::SceneManager::mFogEnd`[protected, inherited]`

| Definition at line 368 of file OgreSceneManager.h.

FogMode Ogre::SceneManager::mFogMode`[protected, inherited]`

| Definition at line 365 of file OgreSceneManager.h.

Real Ogre::SceneManager::mFogStart`[protected, inherited]`

| Definition at line 367 of file OgreSceneManager.h.

Rectangle2D* Ogre::SceneManager::mFullScreenQuad`[protected, inherited]`

| Definition at line 593 of file OgreSceneManager.h.

IlluminationRenderStage Ogre::SceneManager::mIlluminationStage`[protected, inherited]`

| Definition at line 595 of file OgreSceneManager.h.

GpuProgramParametersSharedPtr Ogre::SceneManager::mInfiniteExtrusionParams`[protected, inherited]`

| Definition at line 684 of file OgreSceneManager.h.

InstancedGeometryList Ogre::SceneManager::mInstancedGeometryList`[protected, inherited]`

| Definition at line 314 of file OgreSceneManager.h.

unsigned long Ogre::SceneManager::mLastFrameNumber`[protected, inherited]`

| Definition at line 376 of file OgreSceneManager.h.

LightList Ogre::SceneManager::mLightsAffectingFrustum`[protected, inherited]`

| Definition at line 419 of file OgreSceneManager.h.

ulong Ogre::SceneManager::mLightsDirtyCounter`[protected, inherited]`

| Definition at line 422 of file OgreSceneManager.h.

MovableObjectCollectionMap Ogre::SceneManager::mMovableObjectCollectionMap`[protected, inherited]`

| Definition at line 432 of file OgreSceneManager.h.

String Ogre::SceneManager::mName`[protected, inherited]`

| Instance name. Definition at line 294 of file OgreSceneManager.h.

TexturePtr Ogre::SceneManager::mNullShadowTexture`[protected, inherited]`

| Definition at line 599 of file OgreSceneManager.h.

RenderQueue* Ogre::SceneManager::mRenderQueue`[protected, inherited]`

| Queue of objects for rendering. Definition at line 297 of file OgreSceneManager.h.

RenderQueueListenerList Ogre::SceneManager::mRenderQueueListeners`[protected, inherited]`

| Definition at line 537 of file OgreSceneManager.h.

bool Ogre::SceneManager::mResetIdentityProj`[protected, inherited]`

| Definition at line 379 of file OgreSceneManager.h.

bool Ogre::SceneManager::mResetIdentityView`[protected, inherited]`

| Definition at line 378 of file OgreSceneManager.h.

SceneNodeList Ogre::SceneManager::mSceneNodes`[protected, inherited]`

Central list of SceneNodes - for easy memory management.

Note:
  Note that this list is used only for memory management; the structure of the scene is held using the hierarchy of SceneNodes starting with the root node. However you can look up nodes this way.

Definition at line 324 of file OgreSceneManager.h.

SceneNode* Ogre::SceneManager::mSceneRoot`[protected, inherited]`

| Root scene node. Definition at line 332 of file OgreSceneManager.h.

ShadowCamLightMapping Ogre::SceneManager::mShadowCamLightMapping`[protected, inherited]`

| Definition at line 395 of file OgreSceneManager.h.

AxisAlignedBoxSceneQuery* Ogre::SceneManager::mShadowCasterAABBQuery`[protected, inherited]`

| Definition at line 658 of file OgreSceneManager.h.

ShadowCasterList Ogre::SceneManager::mShadowCasterList`[protected, inherited]`

| Definition at line 656 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowCasterPlainBlackPass`[protected, inherited]`

| A pass designed to let us render shadow colour on white for texture shadows. Definition at line 452 of file OgreSceneManager.h.

ShadowCasterSceneQueryListener* Ogre::SceneManager::mShadowCasterQueryListener`[protected, inherited]`

| Definition at line 719 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShadowCasterRenderBackFaces`[protected, inherited]`

| Definition at line 604 of file OgreSceneManager.h.

SphereSceneQuery* Ogre::SceneManager::mShadowCasterSphereQuery`[protected, inherited]`

| Definition at line 657 of file OgreSceneManager.h.

ColourValue Ogre::SceneManager::mShadowColour`[protected, inherited]`

| Definition at line 586 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowDebugPass`[protected, inherited]`

| Definition at line 587 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowDirLightExtrudeDist`[protected, inherited]`

| Definition at line 594 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowFarDist`[protected, inherited]`

| Definition at line 659 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowFarDistSquared`[protected, inherited]`

| Definition at line 660 of file OgreSceneManager.h.

HardwareIndexBufferSharedPtr Ogre::SceneManager::mShadowIndexBuffer`[protected, inherited]`

| Definition at line 591 of file OgreSceneManager.h.

size_t Ogre::SceneManager::mShadowIndexBufferSize`[protected, inherited]`

| Definition at line 592 of file OgreSceneManager.h.

ShadowListenerList Ogre::SceneManager::mShadowListeners`[protected, inherited]`

| Definition at line 540 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShadowMaterialInitDone`[protected, inherited]`

| Definition at line 590 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowModulativePass`[protected, inherited]`

| Definition at line 589 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowReceiverPass`[protected, inherited]`

| A pass designed to let us render shadow receivers for texture shadows. Definition at line 454 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowStencilPass`[protected, inherited]`

| Definition at line 588 of file OgreSceneManager.h.

ShadowTechnique Ogre::SceneManager::mShadowTechnique`[protected, inherited]`

| Definition at line 584 of file OgreSceneManager.h.

ShadowTextureCameraList Ogre::SceneManager::mShadowTextureCameras`[protected, inherited]`

| Definition at line 601 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShadowTextureConfigDirty`[protected, inherited]`

| Definition at line 597 of file OgreSceneManager.h.

ShadowTextureConfigList Ogre::SceneManager::mShadowTextureConfigList`[protected, inherited]`

| Definition at line 596 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowTextureCustomCasterPass`[protected, inherited]`

| Definition at line 665 of file OgreSceneManager.h.

String Ogre::SceneManager::mShadowTextureCustomCasterVertexProgram`[protected, inherited]`

| Definition at line 667 of file OgreSceneManager.h.

GpuProgramParametersSharedPtr Ogre::SceneManager::mShadowTextureCustomCasterVPParams`[protected, inherited]`

| Definition at line 670 of file OgreSceneManager.h.

GpuProgramParametersSharedPtr Ogre::SceneManager::mShadowTextureCustomReceiverFPParams`[protected, inherited]`

| Definition at line 672 of file OgreSceneManager.h.

String Ogre::SceneManager::mShadowTextureCustomReceiverFragmentProgram`[protected, inherited]`

| Definition at line 669 of file OgreSceneManager.h.

Pass* Ogre::SceneManager::mShadowTextureCustomReceiverPass`[protected, inherited]`

| Definition at line 666 of file OgreSceneManager.h.

String Ogre::SceneManager::mShadowTextureCustomReceiverVertexProgram`[protected, inherited]`

| Definition at line 668 of file OgreSceneManager.h.

GpuProgramParametersSharedPtr Ogre::SceneManager::mShadowTextureCustomReceiverVPParams`[protected, inherited]`

| Definition at line 671 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowTextureFadeEnd`[protected, inherited]`

| Definition at line 663 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowTextureFadeStart`[protected, inherited]`

| Definition at line 662 of file OgreSceneManager.h.

Real Ogre::SceneManager::mShadowTextureOffset`[protected, inherited]`

| Definition at line 661 of file OgreSceneManager.h.

ShadowTextureList Ogre::SceneManager::mShadowTextures`[protected, inherited]`

| Definition at line 598 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShadowTextureSelfShadow`[protected, inherited]`

| Definition at line 664 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShadowUseInfiniteFarPlane`[protected, inherited]`

| Definition at line 603 of file OgreSceneManager.h.

bool Ogre::SceneManager::mShowBoundingBoxes`[protected, inherited]`

| Flag that indicates if all of the scene node's bounding boxes should be shown as a wireframe. Definition at line 556 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyBoxDrawFirst`[protected, inherited]`

| Definition at line 355 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyBoxEnabled`[protected, inherited]`

| Definition at line 354 of file OgreSceneManager.h.

Entity* Ogre::SceneManager::mSkyBoxEntity[6]`[protected, inherited]`

| Definition at line 342 of file OgreSceneManager.h.

SkyBoxGenParameters Ogre::SceneManager::mSkyBoxGenParameters`[protected, inherited]`

| Definition at line 357 of file OgreSceneManager.h.

SceneNode* Ogre::SceneManager::mSkyBoxNode`[protected, inherited]`

| Definition at line 346 of file OgreSceneManager.h.

Quaternion Ogre::SceneManager::mSkyBoxOrientation`[protected, inherited]`

| Definition at line 356 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyDomeDrawFirst`[protected, inherited]`

| Definition at line 360 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyDomeEnabled`[protected, inherited]`

| Definition at line 359 of file OgreSceneManager.h.

Entity* Ogre::SceneManager::mSkyDomeEntity[5]`[protected, inherited]`

| Definition at line 341 of file OgreSceneManager.h.

SkyDomeGenParameters Ogre::SceneManager::mSkyDomeGenParameters`[protected, inherited]`

| Definition at line 362 of file OgreSceneManager.h.

SceneNode* Ogre::SceneManager::mSkyDomeNode`[protected, inherited]`

| Definition at line 345 of file OgreSceneManager.h.

Quaternion Ogre::SceneManager::mSkyDomeOrientation`[protected, inherited]`

| Definition at line 361 of file OgreSceneManager.h.

Plane Ogre::SceneManager::mSkyPlane`[protected, inherited]`

| Definition at line 351 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyPlaneDrawFirst`[protected, inherited]`

| Definition at line 350 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSkyPlaneEnabled`[protected, inherited]`

| Definition at line 349 of file OgreSceneManager.h.

Entity* Ogre::SceneManager::mSkyPlaneEntity`[protected, inherited]`

| Definition at line 340 of file OgreSceneManager.h.

SkyPlaneGenParameters Ogre::SceneManager::mSkyPlaneGenParameters`[protected, inherited]`

| Definition at line 352 of file OgreSceneManager.h.

SceneNode* Ogre::SceneManager::mSkyPlaneNode`[protected, inherited]`

| Definition at line 344 of file OgreSceneManager.h.

SpecialCaseRenderQueueList Ogre::SceneManager::mSpecialCaseQueueList`[protected, inherited]`

| Definition at line 372 of file OgreSceneManager.h.

SpecialCaseRenderQueueMode Ogre::SceneManager::mSpecialCaseQueueMode`[protected, inherited]`

| Definition at line 373 of file OgreSceneManager.h.

StaticGeometryList Ogre::SceneManager::mStaticGeometryList`[protected, inherited]`

| Definition at line 312 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSuppressRenderStateChanges`[protected, inherited]`

| Suppress render state changes? Definition at line 679 of file OgreSceneManager.h.

bool Ogre::SceneManager::mSuppressShadows`[protected, inherited]`

| Suppress shadows? Definition at line 681 of file OgreSceneManager.h.

Matrix4 Ogre::SceneManager::mTempXform[256]`[protected, inherited]`

| Definition at line 377 of file OgreSceneManager.h.

LightInfoList Ogre::SceneManager::mTestLightInfos`[protected, inherited]`

| Definition at line 421 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::mVisibilityMask`[protected, inherited]`

| Visibility mask used to show / hide objects. Definition at line 675 of file OgreSceneManager.h.

uint8 Ogre::SceneManager::mWorldGeometryRenderQueue`[protected, inherited]`

| Definition at line 374 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::STATICGEOMETRY_TYPE_MASK`[static, inherited]`

| Query type mask which will be used for StaticGeometry SceneQuery. Definition at line 228 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::USER_TYPE_MASK_LIMIT`[static, inherited]`

| User type mask limit. Definition at line 232 of file OgreSceneManager.h.

uint32 Ogre::SceneManager::WORLD_GEOMETRY_TYPE_MASK`[static, inherited]`

| Query type mask which will be used for world geometry SceneQuery. Definition at line 222 of file OgreSceneManager.h.

The documentation for this class was generated from the following file:

- OgreSceneManagerEnumerator.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:48:39 2008